"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AbstractDomain = function () {
  function AbstractDomain() {
    _classCallCheck(this, AbstractDomain);
  }

  _createClass(AbstractDomain, [{
    key: "bottom",


    // In set terms, the empty set.
    // Intuitively, a value that should never be observed at runtime.
    value: function bottom() {
      throw Error("Must be overridden");
    }

    // In set terms, a union.
    // Intuitively: what we conservatively know about a variable at the point
    // where two control flows come together into one.

  }, {
    key: "join",
    value: function join(y) {
      var bottom = this.bottom();
      var top = this.top();
      if (this === top || y === top) return top;
      if (this === bottom) return y;
      if (y === bottom) return this;
      return this._join(y);
    }
  }, {
    key: "_join",
    value: function _join(y) {
      throw Error("Must be overridden");
    }

    // Is set terms, the universal set.
    // Intuitively: any allowed value. Which is to say we know
    // absolutely nothing about a variable with abstract value top.

  }, {
    key: "top",
    value: function top() {
      throw Error("Must be overridden");
    }
  }]);

  return AbstractDomain;
}();

exports.default = AbstractDomain;
//# sourceMappingURL=AbstractDomain.js.map