"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright (c) 2017-present, Facebook, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */

exports.default = function (realm) {
  var obj = new _index.ObjectValue(realm, realm.intrinsics.ObjectPrototype, "this");

  obj.$DefineOwnProperty("global", {
    value: obj,
    writable: true,
    enumerable: false,
    configurable: true
  });

  if (realm.compatibility === "browser") obj.$DefineOwnProperty("self", {
    value: obj,
    writable: true,
    enumerable: true,
    configurable: true
  });

  if (realm.compatibility === "browser") obj.$DefineOwnProperty("window", {
    value: obj,
    writable: true,
    enumerable: true,
    configurable: true
  });

  obj.$DefineOwnProperty("setTimeout", {
    value: new _index.NativeFunctionValue(realm, "global.setTimeout", "", 2, function (context, args) {
      throw new Error("TODO: implement global.setTimeout");
    }),
    writable: true,
    enumerable: true,
    configurable: true
  });

  obj.$DefineOwnProperty("setInterval", {
    value: new _index.NativeFunctionValue(realm, "global.setInterval", "", 2, function (context, args) {
      throw new Error("TODO: implement global.setInterval");
    }),
    writable: true,
    enumerable: true,
    configurable: true
  });

  obj.$DefineOwnProperty("dump", {
    value: new _index.NativeFunctionValue(realm, "global.dump", "dump", 0, function (context, args) {
      console.log("dump", args.map(function (arg) {
        return arg.serialise();
      }));
      return context;
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });

  function parseTypeNameOrTemplate(typeNameOrTemplate) {
    if (typeNameOrTemplate === undefined || typeNameOrTemplate instanceof _index.UndefinedValue) {
      return { type: _index.Value, template: undefined };
    } else if (typeNameOrTemplate instanceof _index.StringValue) {
      var typeNameString = (0, _index2.ToStringPartial)(realm, typeNameOrTemplate);
      var _type = _index.Value.getTypeFromName(typeNameString);
      if (_type === undefined) {
        throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "unknown typeNameOrTemplate")]));
      }
      return { type: _type, template: _index.Value.isTypeCompatibleWith(_type, _index.ObjectValue) ? (0, _index2.ObjectCreate)(realm, realm.intrinsics.ObjectPrototype) : undefined };
    } else if (typeNameOrTemplate instanceof _index.ObjectValue) {
      return { type: _index.ObjectValue, template: typeNameOrTemplate };
    } else {
      throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "typeNameOrTemplate has unsupoorted type")]));
    }
  }

  // Helper function to model values that are obtained from the environment,
  // and whose concrete values are not known at Prepack-time.
  // __abstract(typeNameOrTemplate, name, options) creates a new abstract value
  // where typeNameOrTemplate either either 'string', 'boolean', 'number', 'object', or an actual object defining known properties.
  // If the abstract value gets somehow embedded in the final heap,
  // it will be referred to by the supplied name in the generated code.
  obj.$DefineOwnProperty("__abstract", {
    value: new _index.NativeFunctionValue(realm, "global.__abstract", "__abstract", 0, function (context, _ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          typeNameOrTemplate = _ref2[0],
          name = _ref2[1];

      if (!realm.isPartial) {
        throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "realm is not partial")]));
      }

      var _parseTypeNameOrTempl = parseTypeNameOrTemplate(typeNameOrTemplate),
          type = _parseTypeNameOrTempl.type,
          template = _parseTypeNameOrTempl.template;

      var nameString = name ? (0, _index2.ToStringPartial)(realm, name) : "";
      var buildNode = void 0;
      if (nameString === "") {
        var locString = void 0;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = realm.contextStack.slice().reverse()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var executionContext = _step.value;

            var caller = executionContext.caller;
            locString = (0, _Error.describeLocation)(realm, caller ? caller.function : undefined, caller ? caller.lexicalEnvironment : undefined, executionContext.loc);
            if (locString !== undefined) break;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        buildNode = function buildNode() {
          return buildThrowErrorAbstractValue({ LOCATION: t.stringLiteral(locString || "(unknown location)") });
        };
      } else {
        buildNode = (0, _builder2.default)(nameString);
      }

      var types = new _index3.TypesDomain(type);
      var values = template ? new _index3.ValuesDomain(new Set([template])) : _index3.ValuesDomain.topVal;
      var result = realm.createAbstract(types, values, [], buildNode, undefined, nameString);
      if (template) {
        template.makePartial();
        template.intrinsicName = nameString;
        if (nameString) realm.rebuildNestedProperties(result, nameString);
      }
      return result;
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });

  // Helper function that identifies a computation that must remain part of the residual program and cannot be partially evaluated,
  // e.g. because it contains a loop over abstract values.
  // __residual(typeNameOrTemplate, function, arg0, arg1, ...) creates a new abstract value
  // that is computed by invoking function(arg0, arg1, ...) in the residual program and
  // where typeNameOrTemplate either either 'string', 'boolean', 'number', 'object', or an actual object defining known properties.
  // The function must not have side effects, and it must not access any state (besides the supplied arguments).
  // TODO: In some distant future, Prepack should be able to figure out automatically what computations need to remain part of the residual program.
  obj.$DefineOwnProperty("__residual", {
    value: new _index.NativeFunctionValue(realm, "global.__residual", "__residual", 2, function (context, _ref3) {
      var _ref4 = _toArray(_ref3),
          typeNameOrTemplate = _ref4[0],
          f = _ref4[1],
          args = _ref4.slice(2);

      if (!realm.isPartial) {
        throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "realm is not partial")]));
      }

      var _parseTypeNameOrTempl2 = parseTypeNameOrTemplate(typeNameOrTemplate),
          type = _parseTypeNameOrTempl2.type,
          template = _parseTypeNameOrTempl2.template;

      if (f.constructor !== _index.FunctionValue) {
        throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "cannot determine residual function")]));
      }
      (0, _invariant2.default)(f instanceof _index.FunctionValue);
      f.isResidual = true;

      var types = new _index3.TypesDomain(type);
      var values = template ? new _index3.ValuesDomain(new Set([template])) : _index3.ValuesDomain.topVal;
      var result = realm.deriveAbstract(types, values, [f].concat(args), function (nodes) {
        return t.callExpression(nodes[0], nodes.slice(1));
      });
      if (template) {
        template.makePartial();
        realm.rebuildNestedProperties(result, result.buildNode.name);
      }
      return result;
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });

  // Helper function that annotates a function with a string. Useful for marking
  // certain developer-defined properties of the object (e.g. FACTORY_FUNCTION)
  obj.$DefineOwnProperty("__annotate", {
    value: new _index.NativeFunctionValue(realm, "global.__annotate", "__annotate", 2, function (context, _ref5) {
      var _ref6 = _slicedToArray(_ref5, 2),
          func = _ref6[0],
          annotation = _ref6[1];

      // TODO: allow annotation of non-function values
      if (!(func instanceof _index.FunctionValue)) {
        throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "cannot annotate non-function value")]));
      }

      if (!(annotation instanceof _index.StringValue)) {
        throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "annotation must be a string")]));
      }
      context.$Realm.annotations.set(func, annotation.value);

      return context.$Realm.intrinsics.undefined;
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });

  // Internal helper function for tests.
  // __isAbstract(value) checks if a given value is abstract.
  obj.$DefineOwnProperty("__isAbstract", {
    value: new _index.NativeFunctionValue(realm, "global.__isAbstract", "__isAbstract", 1, function (context, _ref7) {
      var _ref8 = _slicedToArray(_ref7, 1),
          value = _ref8[0];

      return new _index.BooleanValue(realm, value instanceof _index.AbstractValue);
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });

  // __makePartial(object) marks an (abstract) object as partial.
  obj.$DefineOwnProperty("__makePartial", {
    value: new _index.NativeFunctionValue(realm, "global.__makePartial", "__isPartial", 1, function (context, _ref9) {
      var _ref10 = _slicedToArray(_ref9, 1),
          object = _ref10[0];

      // casting to any to avoid Flow bug
      if (object instanceof _index.AbstractObjectValue || object instanceof _index.ObjectValue) {
        object.makePartial();
        return context.$Realm.intrinsics.undefined;
      }
      throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "not an (abstract) object")]));
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });

  // __makeSimple(object) marks an (abstract) object as one that has no getters or setters.
  obj.$DefineOwnProperty("__makeSimple", {
    value: new _index.NativeFunctionValue(realm, "global.__makeSimple", "__makeSimple", 1, function (context, _ref11) {
      var _ref12 = _slicedToArray(_ref11, 1),
          object = _ref12[0];

      // casting to any to avoid Flow bug
      if (object instanceof _index.AbstractObjectValue || object instanceof _index.ObjectValue) {
        object.makeSimple();
        return context.$Realm.intrinsics.undefined;
      }
      throw new _completions.ThrowCompletion((0, _index2.Construct)(realm, realm.intrinsics.TypeError, [new _index.StringValue(realm, "not an (abstract) object")]));
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });

  var _arr = ["undefined", "NaN", "Infinity"];
  for (var _i = 0; _i < _arr.length; _i++) {
    var _name = _arr[_i];
    obj.$DefineOwnProperty(_name, {
      value: realm.intrinsics[_name],
      writable: false,
      enumerable: false,
      configurable: false
    });
  }
  var typeNames = ["String", "Object", "Function", "Array", "Number", "RegExp", "Date", "Math", "Error", "Function", "TypeError", "RangeError", "ReferenceError", "SyntaxError", "URIError", "EvalError", "Boolean", "DataView", "Float32Array", "Float64Array", "Int8Array", "Int16Array", "Int32Array", "Map", "WeakMap", "Set", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "ArrayBuffer", "JSON", "__IntrospectionError"];
  if (realm.compatibility !== "jsc") typeNames = typeNames.concat("Symbol", "Promise", "WeakSet", "WeakMap", "Proxy", "Reflect");
  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = typeNames[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var _name2 = _step2.value;

      // need to check if the property exists (it may not due to --compatibility)
      if (realm.intrinsics[_name2]) {
        obj.$DefineOwnProperty(_name2, {
          value: realm.intrinsics[_name2],
          writable: true,
          enumerable: false,
          configurable: true
        });
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  if (realm.compatibility === "jsc") {
    var _arr2 = ["window", "process", "setImmediate", "clearTimeout", "clearInterval", "clearImmediate", "alert", "navigator", "module", "requestAnimationFrame", "cancelAnimationFrame", "requestIdleCallback", "cancelIdleCallback", "Symbol", "Promise", "WeakSet", "WeakMap", "Proxy", "WebSocket", "Request", "Response", "Headers", "FormData", "Worker", "Node", "Blob", "URLSearchParams", "FileReader", "XMLHttpRequest"];

    for (var _i2 = 0; _i2 < _arr2.length; _i2++) {
      var name = _arr2[_i2];
      obj.$DefineOwnProperty(name, {
        value: realm.intrinsics.undefined,
        writable: true,
        enumerable: false,
        configurable: true
      });
    }
  }

  var _arr3 = ["parseFloat", "parseInt", "console", "isNaN", "eval", "isFinite", "encodeURI", "decodeURI", "encodeURIComponent", "decodeURIComponent", "document"];
  for (var _i3 = 0; _i3 < _arr3.length; _i3++) {
    var _name3 = _arr3[_i3];
    obj.$DefineOwnProperty(_name3, {
      value: realm.intrinsics[_name3],
      writable: true,
      enumerable: false,
      configurable: true
    });
  }

  return obj;
};

var _index = require("./values/index.js");

var _index2 = require("./methods/index.js");

var _completions = require("./completions.js");

var _index3 = require("./domains/index.js");

var _builder = require("./utils/builder.js");

var _builder2 = _interopRequireDefault(_builder);

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _invariant = require("./invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

var _Error = require("./intrinsics/ecma262/Error.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var buildThrowErrorAbstractValue = (0, _builder2.default)("(function(){throw new Error('abstract value defined at ' + LOCATION);})()");
//# sourceMappingURL=global.js.map