"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (realm) {
  var obj = new _index.ObjectValue(realm, realm.intrinsics.ObjectPrototype, "console");

  function getString(args) {
    var res = "";
    while (args.length) {
      var next = args.shift();
      var nextString = (0, _to.ToString)(realm, next);
      res += nextString;
    }
    return res;
  }
  obj.defineNativeMethod("log", 0, function (context, args) {
    realm.outputToConsole(getString(args));
    return realm.intrinsics.undefined;
  });

  obj.defineNativeMethod("error", 0, function (context, args) {
    realm.outputToConsole("ERROR: " + getString(args));
    return realm.intrinsics.undefined;
  });

  obj.defineNativeMethod("warn", 0, function (context, args) {
    realm.outputToConsole("warn: " + getString(args));
    return realm.intrinsics.undefined;
  });

  return obj;
};

var _index = require("../../values/index.js");

var _to = require("../../methods/to.js");
//# sourceMappingURL=console.js.map