"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.composeNormalCompletions = composeNormalCompletions;

var _completions = require("../completions.js");

var _index = require("../methods/index.js");

var _index2 = require("../values/index.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function composeNormalCompletions(leftCompletion, rightCompletion, resultValue, realm) {
  if (leftCompletion instanceof _completions.PossiblyNormalCompletion) {
    if (rightCompletion instanceof _completions.PossiblyNormalCompletion) {
      (0, _index.updatePossiblyNormalCompletionWithValue)(realm, rightCompletion, resultValue);
      return (0, _index.composePossiblyNormalCompletions)(realm, leftCompletion, rightCompletion);
    }
    (0, _index.updatePossiblyNormalCompletionWithValue)(realm, leftCompletion, resultValue);
    return leftCompletion;
  } else if (rightCompletion instanceof _completions.PossiblyNormalCompletion) {
    (0, _index.updatePossiblyNormalCompletionWithValue)(realm, rightCompletion, resultValue);
    return rightCompletion;
  } else {
    (0, _invariant2.default)(!leftCompletion && !rightCompletion);
    return resultValue;
  }
} /**
   * Copyright (c) 2017-present, Facebook, Inc.
   * All rights reserved.
   *
   * This source code is licensed under the BSD-style license found in the
   * LICENSE file in the root directory of this source tree. An additional grant
   * of patent rights can be found in the PATENTS file in the same directory.
   */
//# sourceMappingURL=partial.js.map