"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright (c) 2017-present, Facebook, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

// import { transform } from "babel-core";


var _environment = require("./environment.js");

var _realm = require("./realm.js");

var _index = require("./methods/index.js");

var _completions = require("./completions.js");

var _index2 = require("./values/index.js");

var _Error = require("./intrinsics/ecma262/Error.js");

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _generator = require("./utils/generator.js");

var _babelGenerator = require("babel-generator");

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

var _babelTraverse = require("babel-traverse");

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _invariant = require("./invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function isSameNode(left, right) {
  var type = left.type;

  if (type !== right.type) {
    return false;
  }

  if (type === "Identifier") {
    return left.name === right.name;
  }

  if (type === "NullLiteral") {
    return true;
  }

  if (type === "BooleanLiteral" || type === "StringLiteral" || type === "NumericLiteral") {
    return left.value === right.value;
  }

  return false;
}

function markVisited(node, data) {
  node._renamedOnce = data;
}

function shouldVisit(node, data) {
  return node._renamedOnce !== data;
}

// replaceWith causes the node to be re-analysed, so to prevent double replacement
// we add this property on the node to mark it such that it does not get replaced
// again on this pass
// TODO: Make this work when replacing with arbitrary BabelNodeExpressions. Currently
//       if the node that we're substituting contains identifiers as children,
//       they will be visited again and possibly transformed.
//       If necessary we could implement this by following node.parentPath and checking
//       if any parent nodes are marked visited, but that seem unnecessary right now.let closureRefReplacer = {
var closureRefReplacer = {
  ReferencedIdentifier: function ReferencedIdentifier(path, state) {
    var serialisedBindings = state.serialisedBindings;
    var innerName = path.node.name;
    if (path.scope.hasBinding(innerName, /*noGlobals*/true)) return;

    var serialisedBinding = serialisedBindings[innerName];
    if (serialisedBinding && shouldVisit(path.node, serialisedBindings)) {
      markVisited(serialisedBinding.serialisedValue, serialisedBindings);
      path.replaceWith(serialisedBinding.serialisedValue);
    }
  },
  CallExpression: function CallExpression(path, state) {
    // Here we apply the require optimization by replacing require calls with their
    // corresponding initialized modules.
    var requireReturns = state.requireReturns;
    if (!state.isRequire || !state.isRequire(path.scope, path.node)) return;
    state.requireStatistics.count++;
    if (state.modified[path.node.callee.name]) return;

    var moduleId = path.node.arguments[0].value;
    var new_node = requireReturns.get(moduleId);
    if (new_node !== undefined) {
      markVisited(new_node, state.serialisedBindings);
      path.replaceWith(new_node);
      state.requireStatistics.replaced++;
    }
  },
  "AssignmentExpression|UpdateExpression": function AssignmentExpressionUpdateExpression(path, state) {
    var serialisedBindings = state.serialisedBindings;
    var ids = path.getBindingIdentifierPaths();

    for (var innerName in ids) {
      var nestedPath = ids[innerName];
      if (path.scope.hasBinding(innerName, /*noGlobals*/true)) return;

      var serialisedBinding = serialisedBindings[innerName];
      if (serialisedBinding && shouldVisit(nestedPath.node, serialisedBindings)) {
        markVisited(serialisedBinding.serialisedValue, serialisedBindings);
        nestedPath.replaceWith(serialisedBinding.serialisedValue);
      }
    }
  }
};

function visitName(state, name, modified) {
  var doesNotMatter = true;
  var ref = state.serialiser.tryQuery(function () {
    return (0, _index.ResolveBinding)(state.realm, name, doesNotMatter, state.val.$Environment);
  }, undefined, true);
  if (ref === undefined) return;
  if ((0, _index.IsUnresolvableReference)(state.realm, ref)) return;
  state.map[name] = true;
  if (modified) state.functionInfo.modified[name] = true;
}

// TODO doesn't check that `arguments` and `this` is in top function
var closureRefVisitor = {
  ReferencedIdentifier: function ReferencedIdentifier(path, state) {
    var innerName = path.node.name;
    if (innerName === "arguments") {
      state.functionInfo.usesArguments = true;
      return;
    }
    if (path.scope.hasBinding(innerName, /*noGlobals*/true)) return;
    visitName(state, innerName, false);
  },
  ThisExpression: function ThisExpression(path, state) {
    state.functionInfo.usesThis = true;
  },
  CallExpression: function CallExpression(path, state) {
    /*
    This optimization replaces requires to initialized modules with their return
    values. It does this by checking whether the require call has any side effects
    (e.g. modifications to the global module table). Conceptually if a call has
    no side effects, it should be safe to replace with its return value.
     This optimization is not safe in general because it allows for reads to mutable
    global state, but in the case of require, the return value is guaranteed to always
    be the same regardless of that global state modification (because we should
    only be reading from the global module table).
    */
    if (!state.isRequire || !state.isRequire(path.scope, path.node)) return;

    var moduleId = path.node.arguments[0].value;
    state.requiredModules.add(moduleId);
  },
  "AssignmentExpression|UpdateExpression": function AssignmentExpressionUpdateExpression(path, state) {
    for (var name in path.getBindingIdentifiers()) {
      if (path.scope.hasBinding(name, /*noGlobals*/true)) continue;
      visitName(state, name, true);
    }
  }
};

function AreSameSerialisedBindings(x, y) {
  if (x.serialisedValue === y.serialisedValue) return true;
  if (x.value && x.value === y.value) return true;
  return false;
}

var Serialiser = function () {
  function Serialiser() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var initialiseMoreModules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

    _classCallCheck(this, Serialiser);

    this.origOpts = opts;
    this.realm = new _realm.Realm(opts);
    (0, _invariant2.default)(this.realm.isPartial);

    var realmGenerator = this.realm.generator;
    (0, _invariant2.default)(realmGenerator);
    this.generator = realmGenerator;
    var realmPreludeGenerator = this.realm.preludeGenerator;
    (0, _invariant2.default)(realmPreludeGenerator);
    this.preludeGenerator = realmPreludeGenerator;

    this.initialiseMoreModules = initialiseMoreModules;
    this.requiredModules = new Set();
    this._resetSerializeStates();
  }

  _createClass(Serialiser, [{
    key: "_resetSerializeStates",
    value: function _resetSerializeStates() {
      this.declarativeEnvironmentRecordsBindings = new Map();
      this.serialisationStack = [];
      this.delayedSerialisations = [];
      this.delayedKeyedSerialisations = new Map();
      this.globalReasons = {};
      this.prelude = [];
      this.body = [];

      this.unstrictFunctionBodies = [];
      this.strictFunctionBodies = [];

      this.functions = new Map();
      this.functionInstances = [];
      this.refs = new Map();
      this.declaredDerivedIds = new Set();
      this.descriptors = new Map();
      this.needsEmptyVar = false;
    }
    //value to intermediate references generated like $0, $1, $2,...

  }, {
    key: "tryQuery",


    // Wraps a query that might potentially execute user code.
    value: function tryQuery(f, onCompletion, logCompletion) {
      var _this = this;

      var context = new _realm.ExecutionContext();
      var realm = this.realm;
      var env = realm.$GlobalEnv;
      context.lexicalEnvironment = env;
      context.variableEnvironment = env;
      context.realm = realm;
      realm.contextStack.push(context);
      // We use partial evaluation so that we can throw away any state mutations
      try {
        var result = void 0;
        var effects = realm.internal_partially_evaluate(function () {
          try {
            result = f();
          } catch (e) {
            if (e instanceof _completions.Completion) {
              if (logCompletion) _this.logCompletion(e);
              result = onCompletion instanceof Function ? onCompletion(e) : onCompletion;
            } else {
              throw e;
            }
          }
          return realm.intrinsics.undefined;
        });
        (0, _invariant2.default)(effects[0] === realm.intrinsics.undefined);
        return result;
      } finally {
        realm.contextStack.pop();
      }
    }
  }, {
    key: "_getIsRequire",
    value: function _getIsRequire(formalParameters, functions) {
      var realm = this.realm;
      var globalRequire = this.require;
      var serialiser = this;
      return function (scope, node) {
        if (!t.isIdentifier(node.callee) || node.arguments.length !== 1 || !node.arguments[0]) return false;
        var argument = node.arguments[0];
        if (!t.isNumericLiteral(argument) && !t.isStringLiteral(argument)) return false;

        (0, _invariant2.default)(node.callee);
        var innerName = node.callee.name;

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          var _loop = function _loop() {
            var f = _step.value;

            var scopedBinding = scope.getBinding(innerName);
            if (scopedBinding) {
              if (realm.annotations.get(f) === "FACTORY_FUNCTION" && formalParameters[1] === scopedBinding.path.node) {
                (0, _invariant2.default)(scopedBinding.kind === "param");
                return "continue";
              }
              // The name binds to some local entity, but nothing we'd know what exactly it is
              return {
                v: false
              };
            }

            var doesNotMatter = true;
            var reference = serialiser.tryQuery(function () {
              return (0, _index.ResolveBinding)(realm, innerName, doesNotMatter, f.$Environment);
            }, undefined, false);
            if (reference === undefined) {
              // We couldn't resolve as we came across some behavior that we cannot deal with abstractly
              return {
                v: false
              };
            }
            if ((0, _index.IsUnresolvableReference)(realm, reference)) return {
                v: false
              };
            var referencedBase = reference.base;
            var referencedName = reference.referencedName;
            if (typeof referencedName !== "string") return {
                v: false
              };
            var value = void 0;
            if (reference.base instanceof _environment.GlobalEnvironmentRecord) value = (0, _index.Get)(realm, realm.$GlobalObject, innerName);else {
              (0, _invariant2.default)(referencedBase instanceof _environment.DeclarativeEnvironmentRecord);
              var binding = referencedBase.bindings[referencedName];
              if (!binding.initialized) return {
                  v: false
                };
              value = binding.value;
            }
            if (value !== globalRequire) return {
                v: false
              };
          };

          for (var _iterator = functions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _ret = _loop();

            switch (_ret) {
              case "continue":
                continue;

              default:
                if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return true;
      };
    }
  }, {
    key: "logCompletion",
    value: function logCompletion(res) {
      var realm = this.realm;
      var value = res.value;
      console.error("=== " + res.constructor.name + " ===");
      if (this.tryQuery(function () {
        return value instanceof _index2.ObjectValue && (0, _index.InstanceofOperator)(realm, value, realm.intrinsics.Error);
      }, false, false)) {
        var object = value;
        try {
          var err = new Error(this.tryQuery(function () {
            return (0, _index.ToStringPartial)(realm, (0, _index.Get)(realm, object, "message"));
          }, "(unknown message)", false));
          err.stack = this.tryQuery(function () {
            return (0, _index.ToStringPartial)(realm, (0, _index.Get)(realm, object, "stack"));
          }, "(unknown stack)", false);
          console.error(err.message);
          console.error(err.stack);
          if (res instanceof _completions.ThrowCompletion) console.error(res.nativeStack);
        } catch (err) {
          var message = object.properties.get("message");
          console.error(message && message.descriptor && message.descriptor.value instanceof _index2.StringValue ? message.descriptor.value.value : "(no message available)");
          console.error(err.stack);
          console.error(object.$ContextStack);
        }
      } else {
        try {
          value = (0, _index.ToStringPartial)(realm, value);
        } catch (err) {
          value = err.message;
        }
        console.error(value);
        if (res instanceof _completions.ThrowCompletion) console.error(res.nativeStack);
      }
      this._hasErrors = true;
    }
  }, {
    key: "logError",
    value: function logError(message) {
      console.error(message);
      this._hasErrors = true;
    }
  }, {
    key: "execute",
    value: function execute(filename, code, map, onError) {
      var realm = this.realm;
      var res = realm.$GlobalEnv.execute(code, filename, map);

      if (res instanceof _completions.Completion) {
        var context = new _realm.ExecutionContext();
        realm.contextStack.push(context);
        try {
          if (onError) {
            onError(realm, res.value);
          }
          this.logCompletion(res);
        } finally {
          realm.contextStack.pop();
        }
      }

      return res;
    }
  }, {
    key: "shouldInline",
    value: function shouldInline(val) {
      if (val instanceof _index2.SymbolValue) {
        return false;
      }

      if (val instanceof _index2.AbstractValue && val.hasIdentifier()) {
        (0, _invariant2.default)(!this.preludeGenerator.derivedIds.has(val.getIdentifier()) || this.declaredDerivedIds.has(val.getIdentifier()));
        return true;
      }

      if (val.isIntrinsic()) {
        return false;
      }

      return val instanceof _index2.PrimitiveValue;
    }
  }, {
    key: "inferName",
    value: function inferName(val) {
      /*
      if (val instanceof ObjectValue && HasProperty(this.realm, val, "name")) {
        let name = Get(this.realm, val, "name");
        if (name instanceof StringValue) return t.toBindingIdentifierName(name.value);
      }
      */
      return this.preludeGenerator.generateUid();
    }
  }, {
    key: "isNumberWithValue",
    value: function isNumberWithValue(value, n) {
      return !!value && value instanceof _index2.NumberValue && value.value === n;
    }
  }, {
    key: "canIgnoreProperty",
    value: function canIgnoreProperty(val, key, desc) {
      if ((0, _index.IsArray)(this.realm, val)) {
        if (t.isIdentifier(key, { name: "length" }) && desc.writable && !desc.enumerable && !desc.configurable) {
          // length property has the correct descriptor values
          return true;
        }
      } else if (val instanceof _index2.FunctionValue) {
        if (t.isIdentifier(key, { name: "length" }) && !desc.writable && !desc.enumerable && desc.configurable && this.isNumberWithValue(desc.value, val.getArity())) {
          // length property will be inferred already by the amount of parameters
          return true;
        }

        if (t.isIdentifier(key, { name: "name" })) {
          // TODO add the name to `node.id`. ensure that nothing inside can reference it
          return true;
        }

        // Properties `caller` and `arguments` are added to normal functions in non-strict mode to prevent TypeErrors.
        // Because they are autogenerated, they should be ignored.
        if (t.isIdentifier(key, { name: "arguments" }) || t.isIdentifier(key, { name: "caller" })) {
          if (!val.$Strict && desc.writable && !desc.enumerable && desc.configurable && desc.value instanceof _index2.UndefinedValue && val.$FunctionKind === 'normal') return true;
        }
      }

      if (val instanceof _index2.ObjectValue && t.isIdentifier(key, { name: "constructor" })) {
        // TODO only if this is a prototype and the constructor is the value of the root function
        //return true;
      }

      if (val instanceof _index2.ObjectValue && desc.value && desc.value.isIntrinsic()) {
        // TODO only when this prototype would already be set
        return true;
      }

      // ignore the `prototype` property when it consists of a plain javascript object
      if (val instanceof _index2.FunctionValue && t.isIdentifier(key, { name: "prototype" })) {
        // ensure that it's a plain object
        if (desc.value instanceof _index2.ObjectValue && desc.value.$Prototype === this.realm.intrinsics.ObjectPrototype) {
          var valueProperties = desc.value.properties;
          var keys = Array.from(valueProperties.keys());

          // ensure that it's only key is the constructor
          if (keys.length === 1 && keys[0] === "constructor") {
            var binding = valueProperties.get("constructor");
            (0, _invariant2.default)(binding !== undefined);
            var cdesc = binding.descriptor;
            if (cdesc === undefined) return false;
            //todo: check if cdesc is an abstract value that could be empty

            // ensure that the constructor descriptor is correct
            if (cdesc.configurable && !cdesc.enumerable && cdesc.writable && cdesc.value === val) {
              return true;
            }
          }
        }
      }

      return false;
    }
  }, {
    key: "addProperties",
    value: function addProperties(name, val, ignoreEmbedded, reasons) {
      var _this2 = this;

      var descriptors = [];

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = val.properties[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _step2$value = _slicedToArray(_step2.value, 2),
              _key = _step2$value[0],
              propertyBinding = _step2$value[1];

          (0, _invariant2.default)(propertyBinding);
          var desc = propertyBinding.descriptor;
          if (desc === undefined) continue; //deleted
          descriptors.push([t.isValidIdentifier(_key) ? t.identifier(_key) : t.stringLiteral(_key), desc]);
        }

        /*
        for (let symbol of val.symbols.keys()) {
          // TODO: serialise symbols
        }
        */
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      var proto = val.$GetPrototypeOf();
      if (proto.isIntrinsic()) {
        // TODO: serialise modified prototypes that are intrinsic objects
        proto = null;
      }

      if (!descriptors.length && !proto) return;

      // inject properties
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        var _loop2 = function _loop2() {
          var _step3$value = _slicedToArray(_step3.value, 2),
              key = _step3$value[0],
              desc = _step3$value[1];

          if (_this2.canIgnoreProperty(val, key, desc)) return "continue";
          (0, _invariant2.default)(desc !== undefined);
          _this2._eagerOrDelay(_this2._getDescriptorValues(desc).concat(val), function () {
            var uid = _this2._getValIdForReference(val);
            (0, _invariant2.default)(desc !== undefined);
            return _this2._emitProperty(name, uid, key, desc, ignoreEmbedded, reasons);
          });
        };

        for (var _iterator3 = descriptors[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var _ret2 = _loop2();

          if (_ret2 === "continue") continue;
        }

        // prototype
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      if (proto) {
        this._eagerOrDelay([proto, val], function () {
          (0, _invariant2.default)(proto);
          var serialisedProto = _this2.serialiseValue(proto, reasons.concat("Referred to as the prototype for " + name));
          var uid = _this2._getValIdForReference(val);
          if (_this2.realm.compatibility !== "jsc") _this2.body.push(t.expressionStatement(t.callExpression(_this2.preludeGenerator.memoiseReference("Object.setPrototypeOf"), [uid, serialisedProto])));else {
            _this2.body.push(t.expressionStatement(t.assignmentExpression("=", t.memberExpression(uid, t.identifier("__proto__")), serialisedProto)));
          }
        });
      }
    }
  }, {
    key: "_emitProperty",
    value: function _emitProperty(name, uid, key, desc, ignoreEmbedded, reasons) {
      if (this._canEmbedProperty(desc, true)) {
        var descValue = desc.value;
        (0, _invariant2.default)(descValue instanceof _index2.Value);
        if (ignoreEmbedded) return;

        this.body.push(t.expressionStatement(t.assignmentExpression("=", t.memberExpression(uid, key, !t.isIdentifier(key)), this.serialiseValue(descValue, reasons.concat("Referred to in the object " + name + " for the value " + (key.name || key.value))))));
      } else {
        var descProps = [];

        var boolKeys = ["enumerable", "configurable"];
        var valKeys = [];

        if (!desc.get && !desc.set) {
          boolKeys.push("writable");
          valKeys.push("value");
        } else {
          valKeys.push("set", "get");
        }

        var descriptorsKey = [];
        var _iteratorNormalCompletion4 = true;
        var _didIteratorError4 = false;
        var _iteratorError4 = undefined;

        try {
          for (var _iterator4 = boolKeys[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var boolKey = _step4.value;

            if (boolKey in desc) {
              var b = desc[boolKey];
              (0, _invariant2.default)(b !== undefined);
              descProps.push(t.objectProperty(t.identifier(boolKey), t.booleanLiteral(b)));
              descriptorsKey.push(boolKey + ":" + b.toString());
            }
          }
        } catch (err) {
          _didIteratorError4 = true;
          _iteratorError4 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion4 && _iterator4.return) {
              _iterator4.return();
            }
          } finally {
            if (_didIteratorError4) {
              throw _iteratorError4;
            }
          }
        }

        var _iteratorNormalCompletion5 = true;
        var _didIteratorError5 = false;
        var _iteratorError5 = undefined;

        try {
          for (var _iterator5 = valKeys[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var descKey = _step5.value;

            if (descKey in desc) descriptorsKey.push(descKey);
          }
        } catch (err) {
          _didIteratorError5 = true;
          _iteratorError5 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }
          } finally {
            if (_didIteratorError5) {
              throw _iteratorError5;
            }
          }
        }

        descriptorsKey = descriptorsKey.join(",");
        var descriptorId = this.descriptors.get(descriptorsKey);
        if (descriptorId === undefined) {
          descriptorId = t.identifier(this.preludeGenerator.generateUid());
          var declar = t.variableDeclaration("var", [t.variableDeclarator(descriptorId, t.objectExpression(descProps))]);
          this.body.push(declar);
          this.descriptors.set(descriptorsKey, descriptorId);
        }

        var _iteratorNormalCompletion6 = true;
        var _didIteratorError6 = false;
        var _iteratorError6 = undefined;

        try {
          for (var _iterator6 = valKeys[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
            var _descKey = _step6.value;

            if (_descKey in desc) {
              var _descValue = desc[_descKey] || this.realm.intrinsics.undefined;
              (0, _invariant2.default)(_descValue instanceof _index2.Value);
              this.body.push(t.expressionStatement(t.assignmentExpression("=", t.memberExpression(descriptorId, t.identifier(_descKey)), this.serialiseValue(_descValue, reasons.concat("Referred to in the object " + name + " for the key " + (key.name || key.value) + " in the descriptor property " + _descKey)))));
            }
          }
        } catch (err) {
          _didIteratorError6 = true;
          _iteratorError6 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }
          } finally {
            if (_didIteratorError6) {
              throw _iteratorError6;
            }
          }
        }

        var keyRaw = key;
        if (t.isIdentifier(keyRaw)) keyRaw = t.stringLiteral(keyRaw.name);

        this.body.push(t.expressionStatement(t.callExpression(this.preludeGenerator.memoiseReference("Object.defineProperty"), [uid, keyRaw, descriptorId])));
      }
    }
  }, {
    key: "_serialiseDeclarativeEnvironmentRecordBinding",
    value: function _serialiseDeclarativeEnvironmentRecordBinding(r, n, functionName, reasons) {
      var serialisedBindings = this.declarativeEnvironmentRecordsBindings.get(r);
      if (!serialisedBindings) {
        serialisedBindings = Object.create(null);
        this.declarativeEnvironmentRecordsBindings.set(r, serialisedBindings);
      }
      var serialisedBinding = serialisedBindings[n];
      if (!serialisedBinding) {
        var realm = this.realm;
        var binding = r.bindings[n];
        // TODO: handle binding.deletable, binding.mutable
        var _value = binding.initialized && binding.value || realm.intrinsics.undefined;
        var _serialisedValue = this.serialiseValue(_value, reasons.concat("access in " + functionName + " to " + n));
        serialisedBinding = { serialisedValue: _serialisedValue, value: _value };
        serialisedBindings[n] = serialisedBinding;
      }
      return serialisedBinding;
    }
  }, {
    key: "_getValIdForReference",
    value: function _getValIdForReference(val) {
      var id = this._getValIdForReferenceOptional(val);
      (0, _invariant2.default)(id, "Value Id cannot be null or undefined");
      return id;
    }
  }, {
    key: "_getValIdForReferenceOptional",
    value: function _getValIdForReferenceOptional(val) {
      var id = this.refs.get(val);
      if (id) {
        this._incrementValToRefCount(val);
      }
      return id;
    }
  }, {
    key: "_incrementValToRefCount",
    value: function _incrementValToRefCount(val) {

      if (this.collectValToRefCountOnly) {
        var refCount = this.valToRefCount.get(val);
        if (refCount) {
          refCount++;
        } else {
          refCount = 1;
        }
        this.valToRefCount.set(val, refCount);
      }
    }
  }, {
    key: "serialiseValue",
    value: function serialiseValue(val, reasons, referenceOnly, bindingType) {

      var ref = this._getValIdForReferenceOptional(val);
      if (ref) {
        return ref;
      }

      reasons = reasons || [];
      if (!referenceOnly && this.shouldInline(val)) {
        var res = this._serialiseValue("", val, reasons);
        (0, _invariant2.default)(res !== undefined);
        return res;
      }

      var name = this.inferName(val);
      var id = t.identifier(name);
      this.refs.set(val, id);
      this.serialisationStack.push(val);
      var init = this._serialiseValue(name, val, reasons);
      var result = id;
      this._incrementValToRefCount(val);

      if (reasons.length) {
        this.globalReasons[name] = reasons;
      }

      var refCount = this.valToRefCount.get(val);
      (0, _invariant2.default)(refCount !== undefined && refCount > 0);
      if (this.collectValToRefCountOnly || refCount !== 1) {
        if (init) {
          var declar = t.variableDeclaration(bindingType ? bindingType : "var", [t.variableDeclarator(id, init)]);

          declar.leadingComments = [];

          this.body.push(declar);
        }
      } else {
        if (init) {
          this.refs.delete(val);
          result = init;
        }
      }

      this.serialisationStack.pop();
      if (this.serialisationStack.length === 0) {
        while (this.delayedSerialisations.length) {
          (0, _invariant2.default)(this.serialisationStack.length === 0);
          var serialiser = this.delayedSerialisations.shift();
          serialiser();
        }
      }

      return result;
    }
  }, {
    key: "_serialiseValueIntrinsic",
    value: function _serialiseValueIntrinsic(val) {
      (0, _invariant2.default)(val.intrinsicName);
      return this.preludeGenerator.convertStringToMember(val.intrinsicName);
    }
  }, {
    key: "_delay",
    value: function _delay(reason, values, func) {
      (0, _invariant2.default)(reason);
      if (reason === true) {
        this.delayedSerialisations.push(func);
      } else {
        var a = this.delayedKeyedSerialisations.get(reason);
        if (a === undefined) this.delayedKeyedSerialisations.set(reason, a = []);
        a.push({ values: values, func: func });
      }
    }
  }, {
    key: "_getDescriptorValues",
    value: function _getDescriptorValues(desc) {
      if (desc.value !== undefined) return [desc.value];
      (0, _invariant2.default)(desc.get !== undefined);
      (0, _invariant2.default)(desc.set !== undefined);
      return [desc.get, desc.set];
    }
  }, {
    key: "_shouldDelayValues",
    value: function _shouldDelayValues(values) {
      var _iteratorNormalCompletion7 = true;
      var _didIteratorError7 = false;
      var _iteratorError7 = undefined;

      try {
        for (var _iterator7 = values[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
          var _value2 = _step7.value;

          var delayReason = this._shouldDelayValue(_value2);
          if (delayReason) return delayReason;
        }
      } catch (err) {
        _didIteratorError7 = true;
        _iteratorError7 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion7 && _iterator7.return) {
            _iterator7.return();
          }
        } finally {
          if (_didIteratorError7) {
            throw _iteratorError7;
          }
        }
      }

      return false;
    }
  }, {
    key: "_shouldDelayValue",
    value: function _shouldDelayValue(val) {
      var delayReason = void 0;
      if (val instanceof _index2.BoundFunctionValue) {
        delayReason = this._shouldDelayValue(val.$BoundTargetFunction);
        if (delayReason) return delayReason;
        delayReason = this._shouldDelayValue(val.$BoundThis);
        if (delayReason) return delayReason;
        var _iteratorNormalCompletion8 = true;
        var _didIteratorError8 = false;
        var _iteratorError8 = undefined;

        try {
          for (var _iterator8 = val.$BoundArguments[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
            var arg = _step8.value;

            delayReason = this._shouldDelayValue(arg);
            if (delayReason) return delayReason;
          }
        } catch (err) {
          _didIteratorError8 = true;
          _iteratorError8 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }
          } finally {
            if (_didIteratorError8) {
              throw _iteratorError8;
            }
          }
        }
      } else if (val instanceof _index2.FunctionValue) return false;else if (val instanceof _index2.AbstractValue) {
        if (val.hasIdentifier() && !this.declaredDerivedIds.has(val.getIdentifier())) return val.getIdentifier();
        var _iteratorNormalCompletion9 = true;
        var _didIteratorError9 = false;
        var _iteratorError9 = undefined;

        try {
          for (var _iterator9 = val.args[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
            var _arg = _step9.value;

            delayReason = this._shouldDelayValue(_arg);
            if (delayReason) return delayReason;
          }
        } catch (err) {
          _didIteratorError9 = true;
          _iteratorError9 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion9 && _iterator9.return) {
              _iterator9.return();
            }
          } finally {
            if (_didIteratorError9) {
              throw _iteratorError9;
            }
          }
        }
      } else if (val instanceof _index2.ProxyValue) {
        delayReason = this._shouldDelayValue(val.$ProxyTarget);
        if (delayReason) return delayReason;
        delayReason = this._shouldDelayValue(val.$ProxyHandler);
        if (delayReason) return delayReason;
      }

      return this.serialisationStack.indexOf(val) >= 0;
    }
  }, {
    key: "_eagerOrDelay",
    value: function _eagerOrDelay(values, serialiser) {
      var delayReason = this._shouldDelayValues(values);
      if (delayReason) {
        this._delay(delayReason, values, serialiser);
      } else {
        serialiser();
      }
    }
  }, {
    key: "_serialiseValueArray",
    value: function _serialiseValueArray(name, val, reasons) {
      var _this3 = this;

      var realm = this.realm;
      var elems = [];

      // TODO: this shouldn't trigger any user code
      var len = (0, _index.ToLength)(realm, (0, _index.Get)(realm, val, "length"));

      var _loop3 = function _loop3(i) {
        var key = i + "";
        var elem = void 0;
        if ((0, _index.HasProperty)(realm, val, key)) {
          var elemVal = (0, _index.Get)(realm, val, key);
          var delayReason = _this3._shouldDelayValue(elemVal);
          if (delayReason) {
            // handle self recursion
            _this3._delay(delayReason, [elemVal], function () {
              var id = _this3._getValIdForReference(val);
              _this3.body.push(t.expressionStatement(t.assignmentExpression("=", t.memberExpression(id, t.numericLiteral(i), true), _this3.serialiseValue(elemVal, reasons.concat("Declared in array " + name + " at index " + key)))));
            });
            elem = null;
          } else {
            elem = _this3.serialiseValue(elemVal, reasons.concat("Declared in array " + name + " at index " + key));
          }
        } else {
          elem = null;
        }
        elems.push(elem);
      };

      for (var i = 0; i < len; i++) {
        _loop3(i);
      }

      this.addProperties(name, val, true, reasons);
      return t.arrayExpression(elems);
    }
  }, {
    key: "_serialiseValueFunction",
    value: function _serialiseValueFunction(name, val, reasons) {
      var _this4 = this;

      if (val instanceof _index2.BoundFunctionValue) {
        return t.callExpression(t.memberExpression(this.serialiseValue(val.$BoundTargetFunction, reasons.concat("Bound by " + name)), t.identifier("bind")), [].concat(this.serialiseValue(val.$BoundThis, reasons.concat("Bound this of " + name)), val.$BoundArguments.map(function (boundArg, i) {
          return _this4.serialiseValue(boundArg, reasons.concat("Bound argument " + i + " of " + name));
        })));
      }

      if (val instanceof _index2.NativeFunctionValue) {
        throw new Error("TODO: do not know how to serialise non-intrinsic native function value");
      }

      (0, _invariant2.default)(val.constructor === _index2.FunctionValue);
      (0, _invariant2.default)(val.$FormalParameters != null);
      (0, _invariant2.default)(val.$ECMAScriptCode != null);

      var functionInfo = this.functions.get(val.$ECMAScriptCode);

      if (!functionInfo) {
        functionInfo = {
          names: Object.create(null),
          modified: Object.create(null),
          instances: [],
          usesArguments: false,
          usesThis: false
        };
        this.functions.set(val.$ECMAScriptCode, functionInfo);

        var state = { serialiser: this, val: val, reasons: reasons, name: name, functionInfo: functionInfo,
          map: functionInfo.names, realm: this.realm,
          requiredModules: this.requiredModules,
          isRequire: this._getIsRequire(val.$FormalParameters, [val]) };

        (0, _babelTraverse2.default)(t.file(t.program([t.expressionStatement(t.functionExpression(null, val.$FormalParameters, val.$ECMAScriptCode))])), closureRefVisitor, null, state);

        if (val.isResidual && Object.keys(functionInfo.names).length) {
          this.logError("residual function " + ((0, _Error.describeLocation)(this.realm, val, undefined, val.$ECMAScriptCode.loc) || "(unknown)") + " refers to the following identifiers defined outside of the local scope: " + Object.keys(functionInfo.names).join(", "));
        }
      }

      var serialisedBindings = Object.create(null);
      var instance = {
        serialisedBindings: serialisedBindings,
        functionValue: val,
        bodyIndex: -1
      };
      var delayed = 0;

      var _loop4 = function _loop4(innerName) {
        var referencedValues = [];
        var serialiseBindingFunc = void 0;
        var doesNotMatter = true;
        var reference = _this4.tryQuery(function () {
          return (0, _index.ResolveBinding)(_this4.realm, innerName, doesNotMatter, val.$Environment);
        }, undefined, true);
        if (reference === undefined) {
          serialiseBindingFunc = function serialiseBindingFunc() {
            return _this4._serialiseGlobalBinding(innerName);
          };
        } else {
          (0, _invariant2.default)(!(0, _index.IsUnresolvableReference)(_this4.realm, reference));
          var _referencedBase = reference.base;
          var _referencedName = reference.referencedName;
          if (typeof _referencedName !== "string") {
            throw new Error("TODO: do not know how to serialise reference with symbol");
          }
          if (reference.base instanceof _environment.GlobalEnvironmentRecord) {
            serialiseBindingFunc = function serialiseBindingFunc() {
              return _this4._serialiseGlobalBinding(_referencedName);
            };
          } else if (_referencedBase instanceof _environment.DeclarativeEnvironmentRecord) {
            serialiseBindingFunc = function serialiseBindingFunc() {
              (0, _invariant2.default)(_referencedBase instanceof _environment.DeclarativeEnvironmentRecord);
              return _this4._serialiseDeclarativeEnvironmentRecordBinding(_referencedBase, _referencedName, name, reasons);
            };
            var binding = _referencedBase.bindings[_referencedName];
            if (binding.initialized && binding.value) referencedValues.push(binding.value);
          } else {
            (0, _invariant2.default)(false);
          }
        }
        var delayReason = _this4._shouldDelayValues(referencedValues);
        if (delayReason) {
          delayed++;
          _this4._delay(delayReason, referencedValues, function () {
            var serialisedBinding = serialiseBindingFunc();
            (0, _invariant2.default)(serialisedBinding);
            serialisedBindings[innerName] = serialisedBinding;
            (0, _invariant2.default)(functionInfo);
            if (functionInfo.modified[innerName]) serialisedBinding.modified = true;
            if (--delayed === 0) {
              instance.bodyIndex = _this4.body.length;
              _this4.functionInstances.push(instance);
            }
          });
        } else {
          var serialisedBinding = serialiseBindingFunc();
          (0, _invariant2.default)(serialisedBinding);
          serialisedBindings[innerName] = serialisedBinding;
          (0, _invariant2.default)(functionInfo);
          if (functionInfo.modified[innerName]) serialisedBinding.modified = true;
        }
      };

      for (var innerName in functionInfo.names) {
        _loop4(innerName);
      }

      if (delayed === 0) {
        instance.bodyIndex = this.body.length;
        this.functionInstances.push(instance);
      }
      functionInfo.instances.push(instance);

      this.addProperties(name, val, false, reasons);
    }
  }, {
    key: "_canEmbedProperty",
    value: function _canEmbedProperty(prop) {
      var configurable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      return !!prop.writable && !!prop.configurable === configurable && !!prop.enumerable && !prop.set && !prop.get;
    }
  }, {
    key: "_serialiseValueObject",
    value: function _serialiseValueObject(name, val, reasons) {
      var _this5 = this;

      var props = [];

      var _iteratorNormalCompletion10 = true;
      var _didIteratorError10 = false;
      var _iteratorError10 = undefined;

      try {
        var _loop5 = function _loop5() {
          var _step10$value = _slicedToArray(_step10.value, 2),
              key = _step10$value[0],
              propertyBinding = _step10$value[1];

          var prop = propertyBinding.descriptor;
          if (prop === undefined || prop.value === undefined) return "continue"; // deleted
          if (_this5._canEmbedProperty(prop)) {
            var propValue = prop.value;
            (0, _invariant2.default)(propValue instanceof _index2.Value);
            // TODO: revert this when unicode support added
            var keyIsAscii = /^[\u0000-\u007f]*$/.test(key);
            var keyNode = t.isValidIdentifier(key) && keyIsAscii ? t.identifier(key) : t.stringLiteral(key);
            var _delayReason = _this5._shouldDelayValue(propValue);
            if (_delayReason) {
              // self recursion
              _this5._delay(_delayReason, [propValue], function () {
                (0, _invariant2.default)(propValue instanceof _index2.Value);
                var id = _this5._getValIdForReference(val);
                _this5.body.push(t.expressionStatement(t.assignmentExpression("=", t.memberExpression(id, keyNode, t.isStringLiteral(keyNode)), _this5.serialiseValue(propValue, reasons.concat("Referenced in object " + name + " with key " + key)))));
              });
            } else {
              props.push(t.objectProperty(keyNode, _this5.serialiseValue(propValue, reasons.concat("Referenced in object " + name + " with key " + key))));
            }
          }
        };

        for (var _iterator10 = val.properties[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
          var _ret5 = _loop5();

          if (_ret5 === "continue") continue;
        }
      } catch (err) {
        _didIteratorError10 = true;
        _iteratorError10 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion10 && _iterator10.return) {
            _iterator10.return();
          }
        } finally {
          if (_didIteratorError10) {
            throw _iteratorError10;
          }
        }
      }

      this.addProperties(name, val, true, reasons);
      if (val.$RegExpMatcher) {
        var source = val.$OriginalSource;
        var flags = val.$OriginalFlags;
        (0, _invariant2.default)(typeof source === "string");
        (0, _invariant2.default)(typeof flags === "string");
        return t.callExpression(t.identifier("RegExp"), [t.stringLiteral(source), t.stringLiteral(flags)]);
      } else {
        return t.objectExpression(props);
      }
    }
  }, {
    key: "_serialiseValueSymbol",
    value: function _serialiseValueSymbol(val) {
      var args = [];
      if (val.$Description) args.push(t.stringLiteral(val.$Description));
      return t.callExpression(t.identifier("Symbol"), args);
    }
  }, {
    key: "_serialiseValueProxy",
    value: function _serialiseValueProxy(name, val, reasons) {
      return t.newExpression(t.identifier("Proxy"), [this.serialiseValue(val.$ProxyTarget, reasons.concat("Proxy target of " + name)), this.serialiseValue(val.$ProxyHandler, reasons.concat("Proxy handler of " + name))]);
    }
  }, {
    key: "_serialiseAbstractValue",
    value: function _serialiseAbstractValue(name, val, reasons) {
      var _this6 = this;

      var serialisedArgs = val.args.map(function (abstractArg, i) {
        return _this6.serialiseValue(abstractArg, reasons.concat("Argument " + i + " of " + name));
      });
      var serialisedValue = val.buildNode(serialisedArgs);
      if (serialisedValue.type === "Identifier") {
        var id = serialisedValue;
        (0, _invariant2.default)(!this.preludeGenerator.derivedIds.has(id) || this.declaredDerivedIds.has(id));
      }
      return serialisedValue;
    }
  }, {
    key: "_serialiseValue",
    value: function _serialiseValue(name, val, reasons) {
      if (val instanceof _index2.AbstractValue) {
        return this._serialiseAbstractValue(name, val, reasons);
      } else if (val.isIntrinsic()) {
        return this._serialiseValueIntrinsic(val);
      } else if (val instanceof _index2.EmptyValue) {
        this.needsEmptyVar = true;
        return t.identifier("__empty");
      } else if (this.shouldInline(val)) {
        return t.valueToNode(val.serialise());
      } else if ((0, _index.IsArray)(this.realm, val)) {
        (0, _invariant2.default)(val instanceof _index2.ObjectValue);
        return this._serialiseValueArray(name, val, reasons);
      } else if (val instanceof _index2.ProxyValue) {
        return this._serialiseValueProxy(name, val, reasons);
      } else if (val instanceof _index2.FunctionValue) {
        return this._serialiseValueFunction(name, val, reasons);
      } else if (val instanceof _index2.SymbolValue) {
        return this._serialiseValueSymbol(val);
      } else if (val instanceof _index2.ObjectValue) {
        return this._serialiseValueObject(name, val, reasons);
      } else {
        (0, _invariant2.default)(false);
      }
    }
  }, {
    key: "_serialiseGlobalBinding",
    value: function _serialiseGlobalBinding(key) {
      if (t.isValidIdentifier(key)) {
        var _value3 = this.realm.getGlobalLetBinding(key);
        // Check for let binding vs global property
        if (_value3) {
          var id = this.serialiseValue(_value3, ["global let binding"], true, "let");
          // increment ref count one more time as the value has been
          // referentialised (stored in a variable) by serialiseValue
          this._incrementValToRefCount(_value3);
          return {
            serialisedValue: id,
            modified: true, referentialised: true
          };
        } else {
          return { serialisedValue: t.identifier(key), modified: true, referentialised: true };
        }
      } else {
        return { serialisedValue: t.stringLiteral(key), modified: true, referentialised: true };
      }
    }
  }, {
    key: "_initialiseMoreModules",
    value: function _initialiseMoreModules() {
      // partially evaluate all factory methods by calling require
      var realm = this.realm;
      var anyHeapChanges = false;
      // setup execution environment
      var context = new _realm.ExecutionContext();
      var env = realm.$GlobalEnv;
      context.lexicalEnvironment = env;
      context.variableEnvironment = env;
      context.realm = realm;
      realm.contextStack.push(context);
      for (var round = 0; !this._hasErrors; round++) {
        var count = 0;
        var introspectionErrors = Object.create(null);
        var _iteratorNormalCompletion11 = true;
        var _didIteratorError11 = false;
        var _iteratorError11 = undefined;

        try {
          for (var _iterator11 = this.requiredModules[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
            var moduleId = _step11.value;

            if (this.requireReturns.has(moduleId)) continue; // already known to be initialized
            var node = t.callExpression(t.identifier("require"), [t.valueToNode(moduleId)]);

            var _realm$partially_eval = realm.partially_evaluate(node, true, env, false),
                _realm$partially_eval2 = _slicedToArray(_realm$partially_eval, 6),
                compl = _realm$partially_eval2[0],
                gen = _realm$partially_eval2[1],
                bindings = _realm$partially_eval2[2],
                properties = _realm$partially_eval2[3],
                createdObjects = _realm$partially_eval2[4],
                consoleOutput = _realm$partially_eval2[5];

            if (consoleOutput.length > 0) {
              console.log("=== console output during speculative initialization of module " + moduleId + " ===");
              // Dump any console output
              consoleOutput.forEach(function (line) {
                realm.outputToConsole(line);
              });
            }

            if (compl instanceof _completions.Completion) {
              if ((0, _index.IsIntrospectionErrorCompletion)(realm, compl)) {
                var _value4 = compl.value;
                (0, _invariant2.default)(_value4 instanceof _index2.ObjectValue);
                realm.restoreBindings(bindings);
                realm.restoreProperties(properties);
                var message = (0, _index.ToStringPartial)(realm, (0, _index.Get)(realm, _value4, "message"));
                realm.restoreBindings(bindings);
                realm.restoreProperties(properties);
                var moduleIds = introspectionErrors[message] = introspectionErrors[message] || [];
                moduleIds.push(moduleId);
                continue;
              }

              console.log("=== UNEXPECTED ERROR during speculative initialization of module " + moduleId + " ===");
              realm.restoreBindings(bindings);
              realm.restoreProperties(properties);
              this.logCompletion(compl);
              break;
            }

            (0, _invariant2.default)(compl instanceof _index2.Value);

            // Apply the joined effects to the global state
            anyHeapChanges = true;
            realm.restoreBindings(bindings);
            realm.restoreProperties(properties);

            // Add generated code for property modifications
            var realmGenerator = this.realm.generator;
            (0, _invariant2.default)(realmGenerator);
            var _iteratorNormalCompletion13 = true;
            var _didIteratorError13 = false;
            var _iteratorError13 = undefined;

            try {
              for (var _iterator13 = gen.body[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
                var bodyEntry = _step13.value;
                realmGenerator.body.push(bodyEntry);
              }
            } catch (err) {
              _didIteratorError13 = true;
              _iteratorError13 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion13 && _iterator13.return) {
                  _iterator13.return();
                }
              } finally {
                if (_didIteratorError13) {
                  throw _iteratorError13;
                }
              }
            }

            this.requireReturns.set(moduleId, this.serialiseValue(compl));

            // Ignore created objects
            createdObjects;
            count++;
          }
        } catch (err) {
          _didIteratorError11 = true;
          _iteratorError11 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion11 && _iterator11.return) {
              _iterator11.return();
            }
          } finally {
            if (_didIteratorError11) {
              throw _iteratorError11;
            }
          }
        }

        if (count > 0) console.log("=== speculatively initialized " + count + " additional modules");
        if (count === 0) {
          if (!this.collectValToRefCountOnly) {
            var a = [];
            for (var _key2 in introspectionErrors) {
              a.push([introspectionErrors[_key2], _key2]);
            }a.sort(function (x, y) {
              return y[0].length - x[0].length;
            });
            if (a.length) {
              console.log("=== speculative module initialization failures ordered by frequency");
              var _iteratorNormalCompletion12 = true;
              var _didIteratorError12 = false;
              var _iteratorError12 = undefined;

              try {
                for (var _iterator12 = a[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
                  var _step12$value = _slicedToArray(_step12.value, 2),
                      moduleIds = _step12$value[0],
                      n = _step12$value[1];

                  console.log(moduleIds.length + "x " + n + " [" + moduleIds.join(",") + "]");
                }
              } catch (err) {
                _didIteratorError12 = true;
                _iteratorError12 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion12 && _iterator12.return) {
                    _iterator12.return();
                  }
                } finally {
                  if (_didIteratorError12) {
                    throw _iteratorError12;
                  }
                }
              }
            }
          }
          break;
        }
      }
      realm.contextStack.pop();
      return anyHeapChanges;
    }
  }, {
    key: "_resolveRequireReturns",
    value: function _resolveRequireReturns() {
      // partial evaluate all possible requires and see which are possible to inline
      var realm = this.realm;
      this.requireReturns = new Map();
      // setup execution environment
      var context = new _realm.ExecutionContext();
      var env = realm.$GlobalEnv;
      context.lexicalEnvironment = env;
      context.variableEnvironment = env;
      context.realm = realm;
      realm.contextStack.push(context);
      var oldReadOnly = realm.setReadOnly(true);

      var _iteratorNormalCompletion14 = true;
      var _didIteratorError14 = false;
      var _iteratorError14 = undefined;

      try {
        for (var _iterator14 = this.requiredModules[Symbol.iterator](), _step14; !(_iteratorNormalCompletion14 = (_step14 = _iterator14.next()).done); _iteratorNormalCompletion14 = true) {
          var moduleId = _step14.value;

          var node = t.callExpression(t.identifier("require"), [t.valueToNode(moduleId)]);

          var _realm$partially_eval3 = realm.partially_evaluate(node, true, env, false),
              _realm$partially_eval4 = _slicedToArray(_realm$partially_eval3, 6),
              compl = _realm$partially_eval4[0],
              gen = _realm$partially_eval4[1],
              bindings = _realm$partially_eval4[2],
              properties = _realm$partially_eval4[3],
              createdObjects = _realm$partially_eval4[4],
              consoleOutput = _realm$partially_eval4[5];
          // for lint unused


          (0, _invariant2.default)(bindings);

          if (compl instanceof _completions.AbruptCompletion) continue;
          (0, _invariant2.default)(compl instanceof _index2.Value);

          if (gen.body.length !== 0 || consoleOutput.length !== 0 || compl instanceof _index2.ObjectValue && createdObjects.has(compl)) continue;
          // Check for escaping property assignments, if none escape, we're safe
          // to replace the require with its exports object
          var escapes = false;
          var _iteratorNormalCompletion15 = true;
          var _didIteratorError15 = false;
          var _iteratorError15 = undefined;

          try {
            for (var _iterator15 = properties[Symbol.iterator](), _step15; !(_iteratorNormalCompletion15 = (_step15 = _iterator15.next()).done); _iteratorNormalCompletion15 = true) {
              var _step15$value = _slicedToArray(_step15.value, 1),
                  binding = _step15$value[0];

              if (!createdObjects.has(binding.object)) escapes = true;
            }
          } catch (err) {
            _didIteratorError15 = true;
            _iteratorError15 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion15 && _iterator15.return) {
                _iterator15.return();
              }
            } finally {
              if (_didIteratorError15) {
                throw _iteratorError15;
              }
            }
          }

          if (escapes) continue;

          this.requireReturns.set(moduleId, this.serialiseValue(compl));
        }
      } catch (err) {
        _didIteratorError14 = true;
        _iteratorError14 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion14 && _iterator14.return) {
            _iterator14.return();
          }
        } finally {
          if (_didIteratorError14) {
            throw _iteratorError14;
          }
        }
      }

      realm.contextStack.pop();
      realm.setReadOnly(oldReadOnly);
    }
  }, {
    key: "_spliceFunctions",
    value: function _spliceFunctions() {
      var _this7 = this;

      var functionBodies = new Map();
      function getFunctionBody(instance) {
        var b = functionBodies.get(instance);
        if (b === undefined) functionBodies.set(instance, b = []);
        return b;
      }

      var requireStatistics = { replaced: 0, count: 0 };

      // Ensure that all bindings that actually get modified get proper variables
      var functionEntries = Array.from(this.functions.entries());
      var _iteratorNormalCompletion16 = true;
      var _didIteratorError16 = false;
      var _iteratorError16 = undefined;

      try {
        for (var _iterator16 = functionEntries[Symbol.iterator](), _step16; !(_iteratorNormalCompletion16 = (_step16 = _iterator16.next()).done); _iteratorNormalCompletion16 = true) {
          var _step16$value = _slicedToArray(_step16.value, 2),
              _step16$value$ = _step16$value[1],
              _instances = _step16$value$.instances,
              _names = _step16$value$.names;

          var _iteratorNormalCompletion19 = true;
          var _didIteratorError19 = false;
          var _iteratorError19 = undefined;

          try {
            for (var _iterator19 = _instances[Symbol.iterator](), _step19; !(_iteratorNormalCompletion19 = (_step19 = _iterator19.next()).done); _iteratorNormalCompletion19 = true) {
              var instance = _step19.value;

              var _serialisedBindings = instance.serialisedBindings;
              for (var name in _names) {
                var serialisedBinding = _serialisedBindings[name];
                if (serialisedBinding.modified && !serialisedBinding.referentialised) {
                  var serialisedBindingId = t.identifier(this.preludeGenerator.generateUid());
                  var declar = t.variableDeclaration("var", [t.variableDeclarator(serialisedBindingId, serialisedBinding.serialisedValue)]);
                  getFunctionBody(instance).push(declar);
                  serialisedBinding.serialisedValue = serialisedBindingId;
                  serialisedBinding.referentialised = true;
                }
              }
            }
          } catch (err) {
            _didIteratorError19 = true;
            _iteratorError19 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion19 && _iterator19.return) {
                _iterator19.return();
              }
            } finally {
              if (_didIteratorError19) {
                throw _iteratorError19;
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError16 = true;
        _iteratorError16 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion16 && _iterator16.return) {
            _iterator16.return();
          }
        } finally {
          if (_didIteratorError16) {
            throw _iteratorError16;
          }
        }
      }

      var _iteratorNormalCompletion17 = true;
      var _didIteratorError17 = false;
      var _iteratorError17 = undefined;

      try {
        for (var _iterator17 = functionEntries[Symbol.iterator](), _step17; !(_iteratorNormalCompletion17 = (_step17 = _iterator17.next()).done); _iteratorNormalCompletion17 = true) {
          var _step17$value = _slicedToArray(_step17.value, 2),
              funcBody = _step17$value[0],
              _step17$value$ = _step17$value[1],
              _usesArguments = _step17$value$.usesArguments,
              _usesThis = _step17$value$.usesThis,
              _instances2 = _step17$value$.instances,
              _names2 = _step17$value$.names,
              _modified = _step17$value$.modified;

          var params = _instances2[0].functionValue.$FormalParameters;

          var shouldInline = !funcBody;
          if (!shouldInline && funcBody.start && funcBody.end) {
            var bodySize = funcBody.end - funcBody.start;
            shouldInline = bodySize <= 30;
          }

          // TODO: instead of completely giving up creating factories if there are modified bindings,
          // figure out which instances share all they modified bindings, and then create factories for
          // those batches.
          var anySerialisedBindingModified = false;
          var _iteratorNormalCompletion20 = true;
          var _didIteratorError20 = false;
          var _iteratorError20 = undefined;

          try {
            for (var _iterator20 = _instances2[Symbol.iterator](), _step20; !(_iteratorNormalCompletion20 = (_step20 = _iterator20.next()).done); _iteratorNormalCompletion20 = true) {
              var _instance2 = _step20.value;

              var _serialisedBindings4 = _instance2.serialisedBindings;
              for (var _name2 in _names2) {
                var _serialisedBinding2 = _serialisedBindings4[_name2];
                if (_serialisedBinding2.modified) {
                  anySerialisedBindingModified = true;
                }
              }
            }
          } catch (err) {
            _didIteratorError20 = true;
            _iteratorError20 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion20 && _iterator20.return) {
                _iterator20.return();
              }
            } finally {
              if (_didIteratorError20) {
                throw _iteratorError20;
              }
            }
          }

          if (shouldInline || _instances2.length === 1 || _usesArguments || anySerialisedBindingModified) {
            var _iteratorNormalCompletion21 = true;
            var _didIteratorError21 = false;
            var _iteratorError21 = undefined;

            try {
              for (var _iterator21 = _instances2[Symbol.iterator](), _step21; !(_iteratorNormalCompletion21 = (_step21 = _iterator21.next()).done); _iteratorNormalCompletion21 = true) {
                var _instance = _step21.value;
                var _functionValue = _instance.functionValue,
                    _serialisedBindings2 = _instance.serialisedBindings;

                var id = this._getValIdForReference(_functionValue);
                var funcParams = params.slice();
                var funcNode = t.functionDeclaration(id, funcParams, t.cloneDeep(funcBody));

                (0, _babelTraverse2.default)(t.file(t.program([funcNode])), closureRefReplacer, null, { serialisedBindings: _serialisedBindings2,
                  modified: _modified,
                  requireReturns: this.requireReturns,
                  requireStatistics: requireStatistics,
                  isRequire: this._getIsRequire(funcParams, [_functionValue]) });

                if (_functionValue.$Strict) {
                  this.strictFunctionBodies.push(funcNode);
                } else {
                  this.unstrictFunctionBodies.push(funcNode);
                }

                getFunctionBody(_instance).push(funcNode);
              }
            } catch (err) {
              _didIteratorError21 = true;
              _iteratorError21 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion21 && _iterator21.return) {
                  _iterator21.return();
                }
              } finally {
                if (_didIteratorError21) {
                  throw _iteratorError21;
                }
              }
            }
          } else {
            var factoryId = t.identifier(this.preludeGenerator.generateUid());

            // filter included variables to only include those that are different
            var factoryNames = [];
            var sameSerialisedBindings = Object.create(null);
            for (var _name in _names2) {
              var isDifferent = false;
              var lastBinding = void 0;

              var _iteratorNormalCompletion22 = true;
              var _didIteratorError22 = false;
              var _iteratorError22 = undefined;

              try {
                for (var _iterator22 = _instances2[Symbol.iterator](), _step22; !(_iteratorNormalCompletion22 = (_step22 = _iterator22.next()).done); _iteratorNormalCompletion22 = true) {
                  var _ref2 = _step22.value;
                  var _serialisedBindings3 = _ref2.serialisedBindings;

                  var _serialisedBinding = _serialisedBindings3[_name];
                  (0, _invariant2.default)(!_serialisedBinding.modified);
                  if (!lastBinding) {
                    lastBinding = _serialisedBinding;
                  } else if (!AreSameSerialisedBindings(_serialisedBinding, lastBinding)) {
                    isDifferent = true;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError22 = true;
                _iteratorError22 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion22 && _iterator22.return) {
                    _iterator22.return();
                  }
                } finally {
                  if (_didIteratorError22) {
                    throw _iteratorError22;
                  }
                }
              }

              if (isDifferent) {
                factoryNames.push(_name);
              } else {
                (0, _invariant2.default)(lastBinding);
                sameSerialisedBindings[_name] = { serialisedValue: lastBinding.serialisedValue };
              }
            }
            //

            var factoryParams = [];
            var _iteratorNormalCompletion23 = true;
            var _didIteratorError23 = false;
            var _iteratorError23 = undefined;

            try {
              for (var _iterator23 = factoryNames[Symbol.iterator](), _step23; !(_iteratorNormalCompletion23 = (_step23 = _iterator23.next()).done); _iteratorNormalCompletion23 = true) {
                var _key3 = _step23.value;

                factoryParams.push(t.identifier(_key3));
              }
            } catch (err) {
              _didIteratorError23 = true;
              _iteratorError23 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion23 && _iterator23.return) {
                  _iterator23.return();
                }
              } finally {
                if (_didIteratorError23) {
                  throw _iteratorError23;
                }
              }
            }

            factoryParams = factoryParams.concat(params).slice();
            // The Replacer below mutates the AST, so let's clone the original AST to avoid modifying it
            var factoryNode = t.functionDeclaration(factoryId, factoryParams, t.cloneDeep(funcBody));
            this.prelude.push(factoryNode);

            (0, _babelTraverse2.default)(t.file(t.program([factoryNode])), closureRefReplacer, null, { serialisedBindings: sameSerialisedBindings,
              modified: _modified,
              requireReturns: this.requireReturns,
              requireStatistics: requireStatistics,
              isRequire: this._getIsRequire(factoryParams, _instances2.map(function (instance) {
                return instance.functionValue;
              })) });

            //

            var _iteratorNormalCompletion24 = true;
            var _didIteratorError24 = false;
            var _iteratorError24 = undefined;

            try {
              var _loop6 = function _loop6() {
                var instance = _step24.value;
                var functionValue = instance.functionValue,
                    serialisedBindings = instance.serialisedBindings;

                var id = _this7._getValIdForReference(functionValue);
                var flatArgs = factoryNames.map(function (name) {
                  return serialisedBindings[name].serialisedValue;
                });
                var node = void 0;
                if (_usesThis) {
                  var callArgs = [t.thisExpression()];
                  var _iteratorNormalCompletion25 = true;
                  var _didIteratorError25 = false;
                  var _iteratorError25 = undefined;

                  try {
                    for (var _iterator25 = flatArgs[Symbol.iterator](), _step25; !(_iteratorNormalCompletion25 = (_step25 = _iterator25.next()).done); _iteratorNormalCompletion25 = true) {
                      var flatArg = _step25.value;
                      callArgs.push(flatArg);
                    }
                  } catch (err) {
                    _didIteratorError25 = true;
                    _iteratorError25 = err;
                  } finally {
                    try {
                      if (!_iteratorNormalCompletion25 && _iterator25.return) {
                        _iterator25.return();
                      }
                    } finally {
                      if (_didIteratorError25) {
                        throw _iteratorError25;
                      }
                    }
                  }

                  var _iteratorNormalCompletion26 = true;
                  var _didIteratorError26 = false;
                  var _iteratorError26 = undefined;

                  try {
                    for (var _iterator26 = params[Symbol.iterator](), _step26; !(_iteratorNormalCompletion26 = (_step26 = _iterator26.next()).done); _iteratorNormalCompletion26 = true) {
                      var param = _step26.value;

                      if (param.type !== "Identifier") {
                        throw new Error("TODO: do not know how to deal with non-Identifier parameters");
                      }
                      callArgs.push(param);
                    }
                  } catch (err) {
                    _didIteratorError26 = true;
                    _iteratorError26 = err;
                  } finally {
                    try {
                      if (!_iteratorNormalCompletion26 && _iterator26.return) {
                        _iterator26.return();
                      }
                    } finally {
                      if (_didIteratorError26) {
                        throw _iteratorError26;
                      }
                    }
                  }

                  var callee = t.memberExpression(factoryId, t.identifier("call"));

                  var childBody = t.blockStatement([t.returnStatement(t.callExpression(callee, callArgs))]);

                  node = t.functionDeclaration(id, params, childBody);
                } else {
                  node = t.variableDeclaration("var", [t.variableDeclarator(id, t.callExpression(t.memberExpression(factoryId, t.identifier("bind")), [t.nullLiteral()].concat(flatArgs)))]);
                }
                getFunctionBody(instance).push(node);
              };

              for (var _iterator24 = _instances2[Symbol.iterator](), _step24; !(_iteratorNormalCompletion24 = (_step24 = _iterator24.next()).done); _iteratorNormalCompletion24 = true) {
                _loop6();
              }
            } catch (err) {
              _didIteratorError24 = true;
              _iteratorError24 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion24 && _iterator24.return) {
                  _iterator24.return();
                }
              } finally {
                if (_didIteratorError24) {
                  throw _iteratorError24;
                }
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError17 = true;
        _iteratorError17 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion17 && _iterator17.return) {
            _iterator17.return();
          }
        } finally {
          if (_didIteratorError17) {
            throw _iteratorError17;
          }
        }
      }

      var _iteratorNormalCompletion18 = true;
      var _didIteratorError18 = false;
      var _iteratorError18 = undefined;

      try {
        for (var _iterator18 = this.functionInstances.reverse()[Symbol.iterator](), _step18; !(_iteratorNormalCompletion18 = (_step18 = _iterator18.next()).done); _iteratorNormalCompletion18 = true) {
          var _instance3 = _step18.value;

          var functionBody = functionBodies.get(_instance3);
          (0, _invariant2.default)(functionBody !== undefined);
          (0, _invariant2.default)(_instance3.bodyIndex >= 0);
          Array.prototype.splice.apply(this.body, [_instance3.bodyIndex, 0].concat(functionBody));
        }
      } catch (err) {
        _didIteratorError18 = true;
        _iteratorError18 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion18 && _iterator18.return) {
            _iterator18.return();
          }
        } finally {
          if (_didIteratorError18) {
            throw _iteratorError18;
          }
        }
      }

      if (requireStatistics.replaced > 0 && !this.collectValToRefCountOnly) {
        console.log("=== " + this.requireReturns.size + " of " + this.requiredModules.size + " modules initialized, " + requireStatistics.replaced + " of " + requireStatistics.count + " require calls inlined.");
      }
    }
  }, {
    key: "_emitGenerator",
    value: function _emitGenerator(generator) {
      var _this8 = this;

      var reasons = ["Abstract mutation"];
      var serializeValue = this.serialiseValue.bind(this);
      var _iteratorNormalCompletion27 = true;
      var _didIteratorError27 = false;
      var _iteratorError27 = undefined;

      try {
        for (var _iterator27 = generator.body[Symbol.iterator](), _step27; !(_iteratorNormalCompletion27 = (_step27 = _iterator27.next()).done); _iteratorNormalCompletion27 = true) {
          var bodyEntry = _step27.value;

          var nodes = bodyEntry.args.map(function (boundArg, i) {
            return _this8.serialiseValue(boundArg, reasons);
          });
          this.body.push(bodyEntry.buildNode(nodes, serializeValue));
          var id = bodyEntry.declaresDerivedId;
          if (id !== undefined) {
            this.declaredDerivedIds.add(id);
            var a = this.delayedKeyedSerialisations.get(id);
            if (a !== undefined) {
              while (a.length) {
                (0, _invariant2.default)(this.serialisationStack.length === 0);
                (0, _invariant2.default)(this.delayedSerialisations.length === 0);

                var _a$shift = a.shift(),
                    _values = _a$shift.values,
                    _func = _a$shift.func;

                this._eagerOrDelay(_values, _func);
              }
              this.delayedKeyedSerialisations.delete(id);
            }
          }
        }
      } catch (err) {
        _didIteratorError27 = true;
        _iteratorError27 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion27 && _iterator27.return) {
            _iterator27.return();
          }
        } finally {
          if (_didIteratorError27) {
            throw _iteratorError27;
          }
        }
      }

      (0, _invariant2.default)(this.delayedKeyedSerialisations.size === 0);
    }
  }, {
    key: "serialise",
    value: function serialise(filename, code, sourceMaps) {
      var realm = this.realm;

      this.require = (0, _index.Get)(realm, realm.$GlobalObject, "require");

      this._emitGenerator(this.generator);
      (0, _invariant2.default)(this.declaredDerivedIds.size <= this.preludeGenerator.derivedIds.size);

      Array.prototype.push.apply(this.prelude, this.preludeGenerator.prelude);

      // TODO serialise symbols
      // for (let symbol of globalObj.symbols.keys());

      // TODO add timers

      // TODO add event listeners

      this._resolveRequireReturns();
      if (this.initialiseMoreModules) {
        // Note: This may mutate heap state, and render
        if (this._initialiseMoreModules()) return { anyHeapChanges: true };
      }
      this._spliceFunctions();

      // add strict modes
      var strictDirective = t.directive(t.directiveLiteral("use strict"));
      var globalDirectives = [];
      if (!this.unstrictFunctionBodies.length && this.strictFunctionBodies.length) {
        // no unstrict functions, only strict ones
        globalDirectives.push(strictDirective);
      } else if (this.unstrictFunctionBodies.length && this.strictFunctionBodies.length) {
        // strict and unstrict functions
        var _iteratorNormalCompletion28 = true;
        var _didIteratorError28 = false;
        var _iteratorError28 = undefined;

        try {
          funcLoop: for (var _iterator28 = this.strictFunctionBodies[Symbol.iterator](), _step28; !(_iteratorNormalCompletion28 = (_step28 = _iterator28.next()).done); _iteratorNormalCompletion28 = true) {
            var _func2 = _step28.value;

            if (_func2.body.directives) {
              var _iteratorNormalCompletion29 = true;
              var _didIteratorError29 = false;
              var _iteratorError29 = undefined;

              try {
                for (var _iterator29 = _func2.body.directives[Symbol.iterator](), _step29; !(_iteratorNormalCompletion29 = (_step29 = _iterator29.next()).done); _iteratorNormalCompletion29 = true) {
                  var directive = _step29.value;

                  if (directive.value.value === "use strict") {
                    // already have a use strict directive
                    continue funcLoop;
                  }
                }
              } catch (err) {
                _didIteratorError29 = true;
                _iteratorError29 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion29 && _iterator29.return) {
                    _iterator29.return();
                  }
                } finally {
                  if (_didIteratorError29) {
                    throw _iteratorError29;
                  }
                }
              }
            } else _func2.body.directives = [];

            _func2.body.directives.unshift(strictDirective);
          }
        } catch (err) {
          _didIteratorError28 = true;
          _iteratorError28 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion28 && _iterator28.return) {
              _iterator28.return();
            }
          } finally {
            if (_didIteratorError28) {
              throw _iteratorError28;
            }
          }
        }
      }

      // build ast
      var body = [];
      if (this.needsEmptyVar) {
        body = [t.variableDeclaration("var", [t.variableDeclarator(t.identifier("__empty"), t.objectExpression([]))])];
      }
      body = body.concat(this.prelude, this.body);
      this.factorifyObjects(body);

      var ast_body = [];
      if (body.length) {
        if (realm.compatibility === 'node') {
          ast_body.push(t.expressionStatement(t.callExpression(t.memberExpression(t.callExpression(t.identifier("require"), [t.stringLiteral("source-map-support")]), t.identifier("install")), [])));
        }

        ast_body.push(t.expressionStatement(t.callExpression(t.memberExpression(t.functionExpression(null, [], t.blockStatement(body, globalDirectives)), t.identifier("call")), [t.thisExpression()])));
      }

      var ast = {
        type: "File",
        program: {
          type: "Program",
          body: ast_body
        }
      };

      return {
        generated: (0, _babelGenerator2.default)(ast, { sourceMaps: sourceMaps, sourceFileName: filename }, code)
      };
    }
  }, {
    key: "getObjectKeys",
    value: function getObjectKeys(obj) {
      var keys = [];

      var _iteratorNormalCompletion30 = true;
      var _didIteratorError30 = false;
      var _iteratorError30 = undefined;

      try {
        for (var _iterator30 = obj.properties[Symbol.iterator](), _step30; !(_iteratorNormalCompletion30 = (_step30 = _iterator30.next()).done); _iteratorNormalCompletion30 = true) {
          var _prop = _step30.value;

          if (_prop.type !== "ObjectProperty") return false;

          var _key4 = _prop.key;
          if (_key4.type === "StringLiteral") {
            keys.push(_key4.value);
          } else if (_key4.type === "Identifier") {
            if (_prop.computed) return false;
            keys.push(_key4.name);
          } else {
            return false;
          }
        }
      } catch (err) {
        _didIteratorError30 = true;
        _iteratorError30 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion30 && _iterator30.return) {
            _iterator30.return();
          }
        } finally {
          if (_didIteratorError30) {
            throw _iteratorError30;
          }
        }
      }

      var _iteratorNormalCompletion31 = true;
      var _didIteratorError31 = false;
      var _iteratorError31 = undefined;

      try {
        for (var _iterator31 = keys[Symbol.iterator](), _step31; !(_iteratorNormalCompletion31 = (_step31 = _iterator31.next()).done); _iteratorNormalCompletion31 = true) {
          var _key5 = _step31.value;

          if (_key5.indexOf("|") >= 0) return false;
        }
      } catch (err) {
        _didIteratorError31 = true;
        _iteratorError31 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion31 && _iterator31.return) {
            _iterator31.return();
          }
        } finally {
          if (_didIteratorError31) {
            throw _iteratorError31;
          }
        }
      }

      return keys.join("|");
    }
  }, {
    key: "factorifyObjects",
    value: function factorifyObjects(body) {
      var _this9 = this;

      // TODO clean this up...
      var signatures = Object.create(null);

      var _iteratorNormalCompletion32 = true;
      var _didIteratorError32 = false;
      var _iteratorError32 = undefined;

      try {
        for (var _iterator32 = body[Symbol.iterator](), _step32; !(_iteratorNormalCompletion32 = (_step32 = _iterator32.next()).done); _iteratorNormalCompletion32 = true) {
          var _node = _step32.value;

          if (_node.type !== "VariableDeclaration") continue;

          var _iteratorNormalCompletion41 = true;
          var _didIteratorError41 = false;
          var _iteratorError41 = undefined;

          try {
            for (var _iterator41 = _node.declarations[Symbol.iterator](), _step41; !(_iteratorNormalCompletion41 = (_step41 = _iterator41.next()).done); _iteratorNormalCompletion41 = true) {
              var _declar2 = _step41.value;
              var init = _declar2.init;

              (0, _invariant2.default)(init);
              if (init.type !== "ObjectExpression") continue;

              var _keys = this.getObjectKeys(init);
              if (!_keys) continue;

              var _declars = signatures[_keys] = signatures[_keys] || [];
              _declars.push(_declar2);
            }
          } catch (err) {
            _didIteratorError41 = true;
            _iteratorError41 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion41 && _iterator41.return) {
                _iterator41.return();
              }
            } finally {
              if (_didIteratorError41) {
                throw _iteratorError41;
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError32 = true;
        _iteratorError32 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion32 && _iterator32.return) {
            _iterator32.return();
          }
        } finally {
          if (_didIteratorError32) {
            throw _iteratorError32;
          }
        }
      }

      for (var signatureKey in signatures) {
        var declars = signatures[signatureKey];
        if (declars.length < 5) continue;

        var keys = signatureKey.split("|");

        //
        var rootFactoryParams = [];
        var _iteratorNormalCompletion33 = true;
        var _didIteratorError33 = false;
        var _iteratorError33 = undefined;

        try {
          for (var _iterator33 = keys[Symbol.iterator](), _step33; !(_iteratorNormalCompletion33 = (_step33 = _iterator33.next()).done); _iteratorNormalCompletion33 = true) {
            var _key6 = _step33.value;
            rootFactoryParams.push(t.identifier(_key6));
          }
        } catch (err) {
          _didIteratorError33 = true;
          _iteratorError33 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion33 && _iterator33.return) {
              _iterator33.return();
            }
          } finally {
            if (_didIteratorError33) {
              throw _iteratorError33;
            }
          }
        }

        var rootFactoryProps = [];
        var _iteratorNormalCompletion34 = true;
        var _didIteratorError34 = false;
        var _iteratorError34 = undefined;

        try {
          for (var _iterator34 = keys[Symbol.iterator](), _step34; !(_iteratorNormalCompletion34 = (_step34 = _iterator34.next()).done); _iteratorNormalCompletion34 = true) {
            var _key7 = _step34.value;

            var keyNode = t.isValidIdentifier(_key7) ? t.identifier(_key7) : t.stringLiteral(_key7);
            rootFactoryProps.push(t.objectProperty(keyNode, t.identifier(_key7)));
          }
        } catch (err) {
          _didIteratorError34 = true;
          _iteratorError34 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion34 && _iterator34.return) {
              _iterator34.return();
            }
          } finally {
            if (_didIteratorError34) {
              throw _iteratorError34;
            }
          }
        }

        var rootFactoryId = t.identifier(this.preludeGenerator.generateUid());
        var rootFactoryBody = t.blockStatement([t.returnStatement(t.objectExpression(rootFactoryProps))]);
        var rootFactory = t.functionDeclaration(rootFactoryId, rootFactoryParams, rootFactoryBody);
        body.unshift(rootFactory);

        //
        var _iteratorNormalCompletion35 = true;
        var _didIteratorError35 = false;
        var _iteratorError35 = undefined;

        try {
          for (var _iterator35 = declars[Symbol.iterator](), _step35; !(_iteratorNormalCompletion35 = (_step35 = _iterator35.next()).done); _iteratorNormalCompletion35 = true) {
            var declar = _step35.value;

            var args = [];
            var _iteratorNormalCompletion37 = true;
            var _didIteratorError37 = false;
            var _iteratorError37 = undefined;

            try {
              for (var _iterator37 = declar.init.properties[Symbol.iterator](), _step37; !(_iteratorNormalCompletion37 = (_step37 = _iterator37.next()).done); _iteratorNormalCompletion37 = true) {
                var _prop2 = _step37.value;

                args.push(_prop2.value);
              }
            } catch (err) {
              _didIteratorError37 = true;
              _iteratorError37 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion37 && _iterator37.return) {
                  _iterator37.return();
                }
              } finally {
                if (_didIteratorError37) {
                  throw _iteratorError37;
                }
              }
            }

            declar.init = t.callExpression(rootFactoryId, args);
          }

          //
        } catch (err) {
          _didIteratorError35 = true;
          _iteratorError35 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion35 && _iterator35.return) {
              _iterator35.return();
            }
          } finally {
            if (_didIteratorError35) {
              throw _iteratorError35;
            }
          }
        }

        var seen = new Set();
        var _iteratorNormalCompletion36 = true;
        var _didIteratorError36 = false;
        var _iteratorError36 = undefined;

        try {
          var _loop7 = function _loop7() {
            var declar = _step36.value;

            if (seen.has(declar)) return "continue";

            // build up a map containing the arguments that are shared
            var common = new Map();
            var mostSharedArgsLength = 0;
            var _iteratorNormalCompletion38 = true;
            var _didIteratorError38 = false;
            var _iteratorError38 = undefined;

            try {
              for (var _iterator38 = declars[Symbol.iterator](), _step38; !(_iteratorNormalCompletion38 = (_step38 = _iterator38.next()).done); _iteratorNormalCompletion38 = true) {
                var declar2 = _step38.value;

                if (seen.has(declar2)) continue;
                if (declar === declar2) continue;

                var _sharedArgs = [];
                for (var _i = 0; _i < keys.length; _i++) {
                  if (isSameNode(declar.init.arguments[_i], declar2.init.arguments[_i])) {
                    _sharedArgs.push(_i);
                  }
                }
                if (!_sharedArgs.length) continue;

                mostSharedArgsLength = Math.max(mostSharedArgsLength, _sharedArgs.length);
                common.set(declar2, _sharedArgs);
              }

              // build up a mapping of the argument positions that are shared so we can pick the top one
            } catch (err) {
              _didIteratorError38 = true;
              _iteratorError38 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion38 && _iterator38.return) {
                  _iterator38.return();
                }
              } finally {
                if (_didIteratorError38) {
                  throw _iteratorError38;
                }
              }
            }

            var sharedPairs = Object.create(null);
            var _iteratorNormalCompletion39 = true;
            var _didIteratorError39 = false;
            var _iteratorError39 = undefined;

            try {
              for (var _iterator39 = common.entries()[Symbol.iterator](), _step39; !(_iteratorNormalCompletion39 = (_step39 = _iterator39.next()).done); _iteratorNormalCompletion39 = true) {
                var _step39$value = _slicedToArray(_step39.value, 2),
                    _declar = _step39$value[0],
                    _args = _step39$value[1];

                if (_args.length === mostSharedArgsLength) {
                  _args = _args.join(",");
                  var _pair = sharedPairs[_args] = sharedPairs[_args] || [];
                  _pair.push(_declar);
                }
              }

              // get the highest pair
            } catch (err) {
              _didIteratorError39 = true;
              _iteratorError39 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion39 && _iterator39.return) {
                  _iterator39.return();
                }
              } finally {
                if (_didIteratorError39) {
                  throw _iteratorError39;
                }
              }
            }

            var highestPairArgs = void 0;
            var highestPairCount = void 0;
            for (var pairArgs in sharedPairs) {
              var pair = sharedPairs[pairArgs];
              if (!highestPairArgs || pair.length > highestPairCount) {
                highestPairCount = pair.length;
                highestPairArgs = pairArgs;
              }
            }
            if (!highestPairArgs) return "continue";

            //
            var declarsSub = sharedPairs[highestPairArgs].concat(declar);
            var removeArgs = highestPairArgs.split(",");

            var subFactoryArgs = [];
            var subFactoryParams = [];
            var sharedArgs = declarsSub[0].init.arguments;
            for (var i = 0; i < sharedArgs.length; i++) {
              var arg = sharedArgs[i];
              if (removeArgs.indexOf(i + "") >= 0) {
                subFactoryArgs.push(arg);
              } else {
                var id = t.identifier("__" + i);
                subFactoryArgs.push(id);
                subFactoryParams.push(id);
              }
            }

            var subFactoryId = t.identifier(_this9.preludeGenerator.generateUid());
            var subFactoryBody = t.blockStatement([t.returnStatement(t.callExpression(rootFactoryId, subFactoryArgs))]);
            var subFactory = t.functionDeclaration(subFactoryId, subFactoryParams, subFactoryBody);
            body.unshift(subFactory);

            var _iteratorNormalCompletion40 = true;
            var _didIteratorError40 = false;
            var _iteratorError40 = undefined;

            try {
              for (var _iterator40 = declarsSub[Symbol.iterator](), _step40; !(_iteratorNormalCompletion40 = (_step40 = _iterator40.next()).done); _iteratorNormalCompletion40 = true) {
                var declarSub = _step40.value;

                seen.add(declarSub);

                var call = declarSub.init;
                call.callee = subFactoryId;
                call.arguments = call.arguments.filter(function (val, i) {
                  return removeArgs.indexOf(i + "") < 0;
                });
              }
            } catch (err) {
              _didIteratorError40 = true;
              _iteratorError40 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion40 && _iterator40.return) {
                  _iterator40.return();
                }
              } finally {
                if (_didIteratorError40) {
                  throw _iteratorError40;
                }
              }
            }
          };

          for (var _iterator36 = declars[Symbol.iterator](), _step36; !(_iteratorNormalCompletion36 = (_step36 = _iterator36.next()).done); _iteratorNormalCompletion36 = true) {
            var _ret7 = _loop7();

            if (_ret7 === "continue") continue;
          }
        } catch (err) {
          _didIteratorError36 = true;
          _iteratorError36 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion36 && _iterator36.return) {
              _iterator36.return();
            }
          } finally {
            if (_didIteratorError36) {
              throw _iteratorError36;
            }
          }
        }
      }
    }
  }, {
    key: "init",
    value: function init(filename, code) {
      var map = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
      var sourceMaps = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var onError = arguments[4];

      this.execute(filename, code, map, onError);
      if (this._hasErrors) return undefined;
      var savedPG = this.preludeGenerator.save();
      var anyHeapChanges = true;
      this.collectValToRefCountOnly = true;
      while (anyHeapChanges) {
        this.valToRefCount = new Map();
        anyHeapChanges = !!this.serialise(filename, code, sourceMaps).anyHeapChanges;
        if (this._hasErrors) return undefined;
        this.preludeGenerator.restore(savedPG);
        this._resetSerializeStates();
      }
      this.collectValToRefCountOnly = false;
      var serialised = this.serialise(filename, code, sourceMaps);
      (0, _invariant2.default)(!serialised.anyHeapChanges);
      (0, _invariant2.default)(!this._hasErrors);
      return serialised.generated;
    }
  }]);

  return Serialiser;
}();

exports.default = Serialiser;
//# sourceMappingURL=serialiser.js.map