"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require("./index.js");

var _index2 = require("../methods/index.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// A single object typically obtained from a model.
// Unlike a normal object (ObjectValue), a partial object might not
// be supplied with all of the properties it will have at runtime.
//
// Note that values that result from joining distinct object Values
// are instances of AbstractObjectValue.

// TODO: this class does not use the common methods in properties.js,
// which means that assignments to its properites are not tracked in
// Realm.modifiedProperties, which is all sorts of wrong and must be
// fixed soon.

var JoinedObjectsValue = function (_AbstractObjectValue) {
  _inherits(JoinedObjectsValue, _AbstractObjectValue);

  function JoinedObjectsValue(realm, type, options, args, buildNode, kind, intrinsicName) {
    _classCallCheck(this, JoinedObjectsValue);

    (0, _invariant2.default)(_index.Value.isTypeCompatibleWith(type, _index.ObjectValue));
    return _possibleConstructorReturn(this, (JoinedObjectsValue.__proto__ || Object.getPrototypeOf(JoinedObjectsValue)).call(this, realm, type, options, args, buildNode, kind, intrinsicName));
  }

  // ECMA262 9.1.9


  _createClass(JoinedObjectsValue, [{
    key: "$Set",
    value: function $Set(P, V, Receiver) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.AbstractValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      (0, _invariant2.default)(this === Receiver, "TODO");
      (0, _invariant2.default)(this.values.elements.size > 0);

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.values.elements[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var cv = _step.value;

          (0, _invariant2.default)(cv instanceof _index.ObjectValue);
          var d = cv.$GetOwnProperty(P);
          (0, _invariant2.default)(d !== undefined, "TODO: check prototype");
          (0, _invariant2.default)((0, _index2.IsDataDescriptor)(this.$Realm, d));
          var v = (0, _index2.joinValuesAsPropertyGet)(this.$Realm, cv, P, d.value, V);
          cv.$Set(P, v, cv);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (this === this.$Realm.$GlobalObject) {
        this.getGenerator().emitGlobalAssignment(P, V);
      } else {
        this.getGenerator().emitPropertyAssignment(this, P, V);
      }
      return true;
    }
  }]);

  return JoinedObjectsValue;
}(_index.AbstractObjectValue);

exports.default = JoinedObjectsValue;
//# sourceMappingURL=AbstractJoinedObjectsValue.js.map