"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require("./index.js");

var _index2 = require("../methods/index.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OpaqueObjectValue = function (_OpaqueValue) {
  _inherits(OpaqueObjectValue, _OpaqueValue);

  function OpaqueObjectValue(realm, type, options, args, buildNode, kind, intrinsicName) {
    _classCallCheck(this, OpaqueObjectValue);

    (0, _invariant2.default)(_index.Value.isTypeCompatibleWith(type, _index.ObjectValue));

    var _this = _possibleConstructorReturn(this, (OpaqueObjectValue.__proto__ || Object.getPrototypeOf(OpaqueObjectValue)).call(this, realm, type, options, args, buildNode, kind, intrinsicName));

    _this.knownProperties = new Map();
    if (options.template instanceof _index.ObjectValue) _this.applyTemplate(options.template);
    return _this;
  }

  _createClass(OpaqueObjectValue, [{
    key: "applyTemplate",
    value: function applyTemplate(template) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = template.properties[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _step$value = _slicedToArray(_step.value, 2),
              key = _step$value[0],
              propertyBinding = _step$value[1];

          (0, _invariant2.default)(propertyBinding !== undefined);
          var desc = propertyBinding.descriptor;
          if (desc === undefined) continue; // deleted
          (0, _invariant2.default)(desc.value !== undefined, "TODO");
          this.knownProperties.set(key, Object.assign({}, desc));
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: "fetch",
    value: function fetch(P) {
      var _this2 = this;

      var desc = this.knownProperties.get(P);
      if (desc !== undefined) {
        if ((0, _index2.IsDataDescriptor)(this.$Realm, desc)) {
          var _ret = function () {
            var descValue = desc.value;
            (0, _invariant2.default)(descValue !== undefined);
            if (descValue instanceof _index.OpaqueValue && descValue.kind !== "resolved") {
              var options = Object.assign({}, descValue.options);
              if (descValue instanceof OpaqueObjectValue) {
                var template = (0, _index2.ObjectCreate)(_this2.$Realm, _this2.$Realm.intrinsics.ObjectPrototype);
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                  for (var _iterator2 = descValue.knownProperties[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var _step2$value = _slicedToArray(_step2.value, 2),
                        key = _step2$value[0],
                        propDesc = _step2$value[1];

                    if (propDesc !== undefined) {
                      (0, _invariant2.default)(propDesc.value);
                      (0, _index2.CreateDataProperty)(_this2.$Realm, template, key, propDesc.value);
                    }
                  }
                } catch (err) {
                  _didIteratorError2 = true;
                  _iteratorError2 = err;
                } finally {
                  try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                      _iterator2.return();
                    }
                  } finally {
                    if (_didIteratorError2) {
                      throw _iteratorError2;
                    }
                  }
                }

                options.template = template;
              }
              desc.value = _this2.$Realm.generator.derive(descValue.getType(), options, descValue.args, function (nodes) {
                (0, _invariant2.default)(descValue instanceof _index.OpaqueValue);
                return descValue.buildNode(nodes);
              }, "resolved");
            }
            return {
              v: desc
            };
          }();

          if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
        } else if ((0, _index2.IsAccessorDescriptor)(this.$Realm, desc)) {
          (0, _invariant2.default)("TODO");
        } else {
          (0, _invariant2.default)(false);
        }
      }

      if (this.options.canGetAnyNamedProperty) {
        return {
          configurable: true,
          enumerable: true,
          writable: true,
          value: this.$Realm.generator.derive(_index.Value, {}, this.args, function (serialisedArgs) {
            return t.memberExpression(_this2.buildNode(serialisedArgs), t.identifier(P));
          }, typeof this.intrinsicName === "string" ? this.intrinsicName + "." + P : undefined)
        };
      }

      if (this.options.assumeUnknownPropertiesAreAbsent) {
        return undefined;
      }

      return _index.OpaqueValue.throwIntrospectionError(this, P);
    }
  }, {
    key: "$IsExtensible",


    // ECMA262 9.1.3
    value: function $IsExtensible() {
      return !!this.options.isExtensible;
    }

    // ECMA262 9.1.5

  }, {
    key: "$GetOwnProperty",
    value: function $GetOwnProperty(P) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.OpaqueValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      return this.fetch(P);
    }

    // ECMA262 9.1.6

  }, {
    key: "$DefineOwnProperty",
    value: function $DefineOwnProperty(P, Desc) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.OpaqueValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      if (!this.knownProperties.has(P) && !this.options.assumeUnknownPropertiesAreAbsent) {
        return _index.OpaqueValue.throwIntrospectionError(this, P);
      }

      this.knownProperties.set(P, Object.assign({}, Desc));
      if (Desc.value && this === this.$Realm.$GlobalObject) {
        this.$Realm.generator.emitGlobalDeclaration(P, Desc.value);
      } else {
        this.$Realm.generator.emitDefineProperty(this, P, Desc);
      }
      return true;
    }

    // ECMA262 9.1.7

  }, {
    key: "$HasProperty",
    value: function $HasProperty(P) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.OpaqueValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      return this.fetch(P) !== undefined;
    }

    // ECMA262 9.1.8

  }, {
    key: "$Get",
    value: function $Get(P, Receiver) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.OpaqueValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      var desc = this.fetch(P);
      if (desc === undefined) return this.$Realm.intrinsics.undefined;
      (0, _invariant2.default)(desc.value !== undefined);
      return desc.value;
    }

    // ECMA262 9.1.9

  }, {
    key: "$Set",
    value: function $Set(P, V, Receiver) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.OpaqueValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      (0, _invariant2.default)(this === Receiver, "TODO");
      if (!this.knownProperties.has(P) && !this.options.assumeUnknownPropertiesAreAbsent) {
        return _index.OpaqueValue.throwIntrospectionError(this, P);
      }

      var desc = this.knownProperties.get(P);
      if (desc === undefined) {
        this.knownProperties.set(P, desc = { enumerable: true, configurable: true, writable: true, value: V });
      } else {
        if (!desc.writable) return false;
        desc.value = V;
      }

      if (this === this.$Realm.$GlobalObject) {
        this.$Realm.generator.emitGlobalAssignment(P, V);
      } else {
        this.$Realm.generator.emitPropertyAssignment(this, P, V);
      }
      return true;
    }

    // ECMA262 9.1.10

  }, {
    key: "$Delete",
    value: function $Delete(P) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.OpaqueValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      if (!this.knownProperties.has(P) && !this.options.assumeUnknownPropertiesAreAbsent) {
        return _index.OpaqueValue.throwIntrospectionError(this, P);
      }

      var desc = this.knownProperties.get(P);
      if (desc === undefined) return true;
      if (!desc.configurable) return false;
      this.knownProperties.set(P, undefined);

      if (this === this.$Realm.$GlobalObject) {
        this.$Realm.generator.emitGlobalDelete(P);
      } else {
        this.$Realm.generator.emitPropertyDelete(this, P);
      }
      return true;
    }
  }]);

  return OpaqueObjectValue;
}(_index.OpaqueValue);

exports.default = OpaqueObjectValue;
//# sourceMappingURL=OpaqueObjectValue.js.map