"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require("./index.js");

var _completions = require("../completions.js");

var _index2 = require("../methods/index.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OpaqueValue = function (_Value) {
  _inherits(OpaqueValue, _Value);

  function OpaqueValue(realm, type, options, args, buildNode, kind, intrinsicName) {
    _classCallCheck(this, OpaqueValue);

    (0, _invariant2.default)(type === _index.Value || type === _index.NumberValue || type === _index.BooleanValue || type === _index.StringValue || type === _index.ObjectValue || type === _index.FunctionValue, type.name);

    var _this = _possibleConstructorReturn(this, (OpaqueValue.__proto__ || Object.getPrototypeOf(OpaqueValue)).call(this, realm, intrinsicName));

    (0, _invariant2.default)(type !== _index.ObjectValue || _this instanceof _index.OpaqueObjectValue);
    _this.type = type;
    _this.options = Object.assign({}, options);
    delete _this.options.template;
    _this._buildNode = buildNode;
    _this.args = args;
    _this.kind = kind;
    return _this;
  }

  _createClass(OpaqueValue, [{
    key: "getType",
    value: function getType() {
      return this.type;
    }
  }, {
    key: "buildNode",
    value: function buildNode(args) {
      return this._buildNode instanceof Function ? this._buildNode(args) : this._buildNode;
    }
  }, {
    key: "hasIdentifier",
    value: function hasIdentifier() {
      return this._buildNode.type === "Identifier";
    }
  }, {
    key: "getIdentifier",
    value: function getIdentifier() {
      (0, _invariant2.default)(this.hasIdentifier());
      return this._buildNode;
    }
  }, {
    key: "assertReadable",
    value: function assertReadable() {
      return OpaqueValue.throwIntrospectionError(this);
    }
  }], [{
    key: "throwIntrospectionError",
    value: function throwIntrospectionError(val, propertyName) {
      var location = void 0;
      if (propertyName instanceof _index.SymbolValue) location = "at symbol [" + (propertyName.$Description || "(no description)") + "] ";else if (typeof propertyName === "string") location = "at " + propertyName + " ";else location = "";

      var message = "Introspection of " + (val.intrinsicName || (val.hasIdentifier() ? val.getIdentifier().name : "(unknown intrinsic name)")) + " " + location + "isn't allowed on an opaque value";

      throw new _completions.ThrowCompletion((0, _index2.Construct)(val.$Realm, val.$Realm.intrinsics.__IntrospectionError, [new _index.StringValue(val.$Realm, message)]));
    }
  }]);

  return OpaqueValue;
}(_index.Value);

exports.default = OpaqueValue;
//# sourceMappingURL=OpaqueValue.js.map