"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require("./index.js");

var _index2 = require("../methods/index.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// A single object typically obtained from a model.
// Unlike a normal object (ObjectValue), a partial object might not
// be supplied with all of the properties it will have at runtime.
//
// Note that values that result from joining distinct object Values
// are instances of AbstractObjectValue.

// TODO: this class does not use the common methods in properties.js,
// which means that assignments to its properites are not tracked in
// Realm.modifiedProperties, which is all sorts of wrong and must be
// fixed soon.

var PartialObjectValue = function (_AbstractValue) {
  _inherits(PartialObjectValue, _AbstractValue);

  function PartialObjectValue(realm, type, template, args, buildNode, kind, intrinsicName) {
    _classCallCheck(this, PartialObjectValue);

    (0, _invariant2.default)(_index.Value.isTypeCompatibleWith(type, _index.ObjectValue));

    var _this = _possibleConstructorReturn(this, (PartialObjectValue.__proto__ || Object.getPrototypeOf(PartialObjectValue)).call(this, realm, type, args, buildNode, kind, intrinsicName));

    _this.knownProperties = new Map();
    _this.applyTemplate(template);
    return _this;
  }

  _createClass(PartialObjectValue, [{
    key: "applyTemplate",
    value: function applyTemplate(template) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = template.properties[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _step$value = _slicedToArray(_step.value, 2),
              key = _step$value[0],
              propertyBinding = _step$value[1];

          (0, _invariant2.default)(propertyBinding !== undefined);
          var desc = propertyBinding.descriptor;
          if (desc === undefined || (0, _index2.IsKnownEmpty)(desc.value)) continue; // deleted
          (0, _invariant2.default)(desc.value !== undefined, "TODO");
          this.knownProperties.set(key, Object.assign({}, desc));
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: "fetch",
    value: function fetch(P) {
      var _this2 = this;

      var desc = this.knownProperties.get(P);
      if (desc !== undefined) {
        if ((0, _index2.IsDataDescriptor)(this.$Realm, desc)) {
          var _ret = function () {
            var descValue = desc.value;
            (0, _invariant2.default)(descValue !== undefined);
            if (descValue instanceof _index.AbstractValue && descValue.kind !== "resolved") {
              var template = void 0;
              if (descValue instanceof PartialObjectValue) {
                template = (0, _index2.ObjectCreate)(_this2.$Realm, _this2.$Realm.intrinsics.ObjectPrototype);
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                  for (var _iterator2 = descValue.knownProperties[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var _step2$value = _slicedToArray(_step2.value, 2),
                        key = _step2$value[0],
                        propDesc = _step2$value[1];

                    if (propDesc !== undefined) {
                      (0, _invariant2.default)(propDesc.value);
                      (0, _index2.CreateDataProperty)(_this2.$Realm, template, key, propDesc.value);
                    }
                  }
                } catch (err) {
                  _didIteratorError2 = true;
                  _iteratorError2 = err;
                } finally {
                  try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                      _iterator2.return();
                    }
                  } finally {
                    if (_didIteratorError2) {
                      throw _iteratorError2;
                    }
                  }
                }
              }
              desc.value = _this2.getGenerator().derive(descValue.getType(), template, descValue.args, function (nodes) {
                (0, _invariant2.default)(descValue instanceof _index.AbstractValue);
                return descValue.buildNode(nodes);
              }, "resolved");
            }
            return {
              v: desc
            };
          }();

          if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
        } else if ((0, _index2.IsAccessorDescriptor)(this.$Realm, desc)) {
          (0, _invariant2.default)("TODO");
        } else {
          (0, _invariant2.default)(false);
        }
      }

      return _index.AbstractValue.throwIntrospectionError(this, P);
    }

    // TODO: consider alternative designs
    // At the very least the key should include symbols
    // and the value should be PropertyBindings.

  }, {
    key: "assertObject",
    value: function assertObject() {
      return this;
    }

    // ECMA262 9.1.3

  }, {
    key: "$IsExtensible",
    value: function $IsExtensible() {
      return false;
    }

    // ECMA262 9.1.5

  }, {
    key: "$GetOwnProperty",
    value: function $GetOwnProperty(P) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.AbstractValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      return this.fetch(P);
    }

    // ECMA262 9.1.6

  }, {
    key: "$DefineOwnProperty",
    value: function $DefineOwnProperty(P, Desc) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.AbstractValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      if (!this.knownProperties.has(P)) {
        return _index.AbstractValue.throwIntrospectionError(this, P);
      }

      this.knownProperties.set(P, Object.assign({}, Desc));
      var value = Desc.value;
      if (value && this === this.$Realm.$GlobalObject) {
        this.getGenerator().emitGlobalDeclaration(P, value);
      } else {
        this.getGenerator().emitDefineProperty(this, P, Desc);
      }
      return true;
    }

    // ECMA262 9.1.7

  }, {
    key: "$HasProperty",
    value: function $HasProperty(P) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.AbstractValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      return this.fetch(P) !== undefined;
    }

    // ECMA262 9.1.8

  }, {
    key: "$Get",
    value: function $Get(P, Receiver) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.AbstractValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      var desc = this.fetch(P);
      if (desc === undefined) return this.$Realm.intrinsics.undefined;
      (0, _invariant2.default)(desc.value !== undefined);
      return desc.value;
    }

    // ECMA262 9.1.9

  }, {
    key: "$Set",
    value: function $Set(P, V, Receiver) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.AbstractValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      (0, _invariant2.default)(this === Receiver, "TODO");
      if (!this.knownProperties.has(P)) {
        return _index.AbstractValue.throwIntrospectionError(this, P);
      }

      var desc = this.knownProperties.get(P);
      if (desc === undefined) {
        this.knownProperties.set(P, desc = { enumerable: true, configurable: true, writable: true, value: V });
      } else {
        if (!desc.writable) return false;
        desc.value = V;
      }
      //todo: track the property assignment

      if (this === this.$Realm.$GlobalObject) {
        this.getGenerator().emitGlobalAssignment(P, V);
      } else {
        this.getGenerator().emitPropertyAssignment(this, P, V);
      }
      return true;
    }

    // ECMA262 9.1.10

  }, {
    key: "$Delete",
    value: function $Delete(P) {
      if (P instanceof _index.StringValue) P = P.value;else if (P instanceof _index.SymbolValue) return _index.AbstractValue.throwIntrospectionError(this, P);
      (0, _invariant2.default)(typeof P === "string");
      if (!this.knownProperties.has(P)) {
        return _index.AbstractValue.throwIntrospectionError(this, P);
      }

      var desc = this.knownProperties.get(P);
      if (desc === undefined) return true;
      if (!desc.configurable) return false;
      this.knownProperties.set(P, undefined);

      if (this === this.$Realm.$GlobalObject) {
        this.getGenerator().emitGlobalDelete(P);
      } else {
        this.getGenerator().emitPropertyDelete(this, P);
      }
      return true;
    }
  }]);

  return PartialObjectValue;
}(_index.AbstractValue);

exports.default = PartialObjectValue;
//# sourceMappingURL=PartialObjectValue.js.map